package PuellaMagi.mods;

import net.minecraft.block.Block;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLiving;
import net.minecraft.util.MathHelper;
import net.minecraft.util.MovingObjectPosition;
import net.minecraft.util.Vec3;
import net.minecraft.world.World;

public class EntityFireLance extends EntityMadomagiThrowable
{
    public EntityFireLance(World par1World)
    {
        super(par1World);
    }

    public EntityFireLance(World par1World, EntityLiving par2EntityLiving, float par3)
    {
        super(par1World, par2EntityLiving, par3);
    }

    public EntityFireLance(World par1World, EntityLiving par2EntityLiving, EntityLiving par3EntityLiving, float par4, float par5)
    {
        super(par1World, par2EntityLiving);
        Vec3 var14 = par2EntityLiving.getLook(1.0F);
        this.posX = par2EntityLiving.boundingBox.minX + (double)(par2EntityLiving.width / 2.0F) + var14.xCoord * 8.0D;
        this.posY = par2EntityLiving.boundingBox.minY + (double)(par2EntityLiving.height / 2.0F) + var14.yCoord * 16.0D;
        this.posZ = par2EntityLiving.boundingBox.minZ + (double)(par2EntityLiving.width / 2.0F) + var14.yCoord * 8.0D;
        double var1 = 0.5D;
        if (par3EntityLiving.height >= 10.0F)
        {
        	var1 = 0.05D;
        }
        double var6 = par3EntityLiving.posX - this.posX;
        double var8 = par3EntityLiving.posY + (double)par3EntityLiving.height * var1 - this.posY;
        double var10 = par3EntityLiving.posZ - this.posZ;
        float var12 = MathHelper.sqrt_double(var6 * var6 + var10 * var10) * 0.2F;
        this.setThrowableHeading(var6, var8 + (double)var12, var10, par4, par5);
    }

    public EntityFireLance(World par1World, double par2, double par4, double par6)
    {
        super(par1World, par2, par4, par6);
    }

    @Override
    protected void onImpact(MovingObjectPosition par1MovingObjectPosition)
    {
        if (par1MovingObjectPosition.entityHit == null || par1MovingObjectPosition.entityHit.getClass() != EntityWalpurgisnacht.class)
        {
        	super.onImpact(par1MovingObjectPosition);
        }
        if (par1MovingObjectPosition.entityHit == null && !this.worldObj.isRemote)
        {
        	int var2 = par1MovingObjectPosition.blockX;
        	int var3 = par1MovingObjectPosition.blockY;
        	int var4 = par1MovingObjectPosition.blockZ;
        	int var5 = this.worldObj.getBlockId(var2, var3, var4);
        	if (var5 > 0 && var5 != Block.bedrock.blockID)
        	{
        		this.worldObj.setBlockWithNotify(var2, var3, var4, 0);
        	}
        }
    }
}