package PuellaMagi.mods;

import net.minecraft.entity.Entity;
import net.minecraft.entity.ai.EntityAIAttackOnCollide;
import net.minecraft.entity.ai.EntityAIHurtByTarget;
import net.minecraft.entity.ai.EntityAILookIdle;
import net.minecraft.entity.ai.EntityAINearestAttackableTarget;
import net.minecraft.entity.ai.EntityAISwimming;
import net.minecraft.entity.ai.EntityAIWander;
import net.minecraft.entity.ai.EntityAIWatchClosest;
import net.minecraft.entity.passive.EntityVillager;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.world.World;

public class EntityGertrud extends EntityMajo
{
    public EntityGertrud(World par1World)
    {
        super(par1World);
        this.texture = "/PuellaMagi/Mobs/gertrud.png";
        this.setSize(2.0F, 6.0F);
        this.moveSpeed = 0.4F;

        this.tasks.addTask(0, new EntityAISwimming(this));
        this.tasks.addTask(3, new EntityAIAttackOnCollide(this, this.moveSpeed, false));
        this.tasks.addTask(6, new EntityAIWander(this, this.moveSpeed));
        this.tasks.addTask(7, new EntityAIWatchClosest(this, EntityPlayer.class, 8.0F));
        this.tasks.addTask(7, new EntityAILookIdle(this));
        this.targetTasks.addTask(1, new EntityAIHurtByTarget(this, false));
        this.targetTasks.addTask(2, new EntityAINearestAttackableTarget(this, EntityMahoShojo.class, 16.0F, 0, false));
        this.targetTasks.addTask(3, new EntityAINearestAttackableTarget(this, EntityVillager.class, 16.0F, 0, false));
        this.targetTasks.addTask(4, new EntityAINearestAttackableTarget(this, EntityPlayer.class, 16.0F, 0, false));
    }

    @Override
    public int getMaxHealth()
    {
        return 40;
    }

    @Override
    protected void dropFewItems(boolean par1, int par2)
    {
        this.dropItem(mod_QB.itemGriefSeed.shiftedIndex, 1);
    }

    @Override
    protected EntityMajo getServant()
    {
        if (this.rand.nextInt(3) == 0)
        {
        	return new EntityAdelbert(this.worldObj);
        }
        return new EntityAnthony(this.worldObj);
    }

    @Override
    public int getAttackStrength(Entity par1Entity)
    {
        return 10;
    }
}