package PuellaMagi.mods;

import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLiving;
import net.minecraft.entity.ai.EntityAIAttackOnCollide;
import net.minecraft.entity.ai.EntityAIHurtByTarget;
import net.minecraft.entity.ai.EntityAILookIdle;
import net.minecraft.entity.ai.EntityAISwimming;
import net.minecraft.entity.ai.EntityAIWander;
import net.minecraft.entity.ai.EntityAIWatchClosest;
import net.minecraft.entity.boss.IBossDisplayData;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.DamageSource;
import net.minecraft.world.World;

public class EntityKriemhildGretchen extends EntityMajo implements IBossDisplayData
{
    private int superArmor;
    public EntityKriemhildGretchen(World par1World)
    {
        super(par1World);
        this.texture = "/mob/creeper.png";
        this.setSize(10.0F, 30.0F);
        this.moveSpeed = 3.75F;
        this.superArmor = 0;

        this.tasks.addTask(0, new EntityAISwimming(this));
        this.tasks.addTask(1, new EntityMajoAIKriemhild(this, EntityLiving.class, 32.0F));
        this.tasks.addTask(2, new EntityAIAttackOnCollide(this, this.moveSpeed, true));
        this.tasks.addTask(6, new EntityAIWander(this, this.moveSpeed));
        this.tasks.addTask(7, new EntityAIWatchClosest(this, EntityPlayer.class, 8.0F));
        this.tasks.addTask(7, new EntityAILookIdle(this));
        this.targetTasks.addTask(1, new EntityAIHurtByTarget(this, false));
    }

    @Override
    public int getMaxHealth()
    {
        return 200;
    }

    @Override
    public boolean attackEntityFrom(DamageSource par1DamageSource, int par2)
    {
        int var1 = par2;
        if (par1DamageSource.isFireDamage() || this.superArmor != 0 || (par1DamageSource.getEntity() == null && this.getRNG().nextInt(3) != 0) || par1DamageSource.getEntity() == this)
        {
        	var1 = 0;
        }
        if (var1 > 0)
        {
        	this.superArmor = 20;
        	if (var1 > 10)
        	{
        		var1 = 10;
        	}
        }
        return super.attackEntityFrom(par1DamageSource, var1);
    }

    @Override
    public void onLivingUpdate()
    {
        if (this.superArmor > 0)
        {
        	this.superArmor--;
        }
    }

    @Override
    protected void updateAITick()
    {
        this.dataWatcher.updateObject(18, Integer.valueOf(this.getHealth()));
    }

    @Override
    public int getDragonHealth()
    {
       return this.dataWatcher.getWatchableObjectInt(18);
    }

    @Override
    protected void entityInit()
    {
        super.entityInit();
        this.dataWatcher.addObject(18, new Integer(this.getHealth()));
    }

    @Override
    protected void dropFewItems(boolean par1, int par2)
    {
        this.dropItem(mod_QB.itemGriefSeed.shiftedIndex, 1);
    }

    @Override
    public int getAttackStrength(Entity par1Entity)
    {
        return 3;
    }
}