package PuellaMagi.mods;

import net.minecraft.enchantment.Enchantment;
import net.minecraft.enchantment.EnchantmentHelper;
import net.minecraft.entity.EntityLiving;
import net.minecraft.entity.ai.EntityAILookIdle;
import net.minecraft.entity.ai.EntityAISwimming;
import net.minecraft.entity.ai.EntityAIWander;
import net.minecraft.entity.ai.EntityAIWatchClosest;
import net.minecraft.entity.item.EntityTNTPrimed;
import net.minecraft.entity.monster.EntityMob;
import net.minecraft.entity.monster.EntitySlime;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.DamageSource;
import net.minecraft.util.MathHelper;
import net.minecraft.world.World;

public class EntityKyouko extends EntityMahoShojo
{
    private int rapidFire;

    public EntityKyouko(World par1World)
    {
        super(par1World);
        this.texture = "/PuellaMagi/Mobs/kyouko.png";
        this.MSTexture = "/PuellaMagi/Mobs/kyoukoMS.png";
        this.attackStrength = 1;
        this.MSAttackStrength = 20;
        this.moveSpeed = 0.3F;
        this.soulGemID = mod_QB.kyoukoGem.shiftedIndex;
        this.rapidFire = 0;
        ItemStack var1 = new ItemStack(mod_QB.kyoukoSpear);

        this.getNavigator().setAvoidsWater(true);
        this.tasks.addTask(1, new EntityAISwimming(this));
        this.tasks.addTask(2, new EntityMadomagiAIAvoidEntity(this, EntityTNTPrimed.class, 16.0F, this.moveSpeed, this.moveSpeed + 0.2F));
        this.tasks.addTask(3, new EntityMadomagiAIStandby(this));
        this.tasks.addTask(4, new EntityMadomagiAIShortRangeAttack(this, this.moveSpeed + 0.2F, 15.0F, var1));
        this.tasks.addTask(5, new EntityMadomagiAIMiddleRangeAttack(this, this.moveSpeed + 0.2F, 5.0F, var1));
        this.tasks.addTask(6, new EntityMadomagiAILongRangeAttack(this, this.moveSpeed, 16.0F, var1));
        this.tasks.addTask(6, new EntityMadomagiAITeaTime(this, new ItemStack(Item.appleRed), false, 1));
        this.tasks.addTask(7, new EntityMadomagiAIFollowOwner(this, this.moveSpeed, 1.5F));
        this.tasks.addTask(8, new EntityAIWander(this, this.moveSpeed));
        this.tasks.addTask(9, new EntityAIWatchClosest(this, EntityPlayer.class, 8.0F));
        this.tasks.addTask(9, new EntityAILookIdle(this));
        this.targetTasks.addTask(1, new EntityMadomagiAIOwnerHurtByTarget(this));
        this.targetTasks.addTask(2, new EntityMadomagiAIOwnerHurtTarget(this));
        this.targetTasks.addTask(3, new EntityMadomagiAINearestAttackableTarget(this, EntityMob.class, 16.0F, 4.0F, true));
        this.targetTasks.addTask(4, new EntityMadomagiAINearestAttackableTarget(this, EntitySlime.class, 16.0F, 2.0F, true));
    }

    @Override
    public int getMaxHealth()
    {
        return 16;
    }

    @Override
    public boolean attackEntityFrom(DamageSource par1DamageSource, int par2)
    {
        if (!this.worldObj.isRemote && !(par1DamageSource.getEntity() instanceof EntityPlayer) && this.isTransformation() && this.isEntityAlive())
        {
        	if (this.getActionTick() == 0)
        	{
        		this.chatMessage("GUARD!");
        		this.setActionTick(12);
        		return false;
        	}
        	else if (this.rand.nextInt(10) == 0)
        	{
        		this.chatMessage("DODGE!");
        		return false;
        	}
        }
        return super.attackEntityFrom(par1DamageSource, par2);
    }

    @Override
    public int shortRangeAttack(EntityLiving par1EntityLiving, int par2)
    {
        double var2 = (double)((this.width + par1EntityLiving.width + 1.0D) * (this.width + par1EntityLiving.width + 1.0D));
        if (this.getDistanceSq(par1EntityLiving.posX, par1EntityLiving.posY, par1EntityLiving.posZ) < var2)
        {
        	if (par2 <= 0)
        	{
        		if (this.getHeldItem() != null)
        		{
        			this.swingItem();
        		}
        		if (this.attackEntityAsMob(par1EntityLiving))
        		{
        			double var1 = (this.rand.nextInt(3) - 1) * 1.0D;
        			double var3 = (this.rand.nextInt(3) - 1) * 1.0D;
        			double var5 = (this.rand.nextInt(3) - 1) * 1.0D;
        			double var7 = (double)MathHelper.sqrt_double(var1 * var1 + var3 * var3 + var5 * var5);
        			if (var7 > 0.0F)
        			{
        				par1EntityLiving.addVelocity(var1 / var7, var3 / var7, var7 / var7);
        			}
        		}
        		this.setSoulGemDamage(1);
        		return 8;
        	}
        }
        return par2;
    }

    @Override
    public int middleRangeAttack(EntityLiving par1EntityLiving, int par2)
    {
        if (par2 <= 0)
        {
        	double var2 = par1EntityLiving.posX - this.posX;
        	double var4 = par1EntityLiving.posY + (double)par1EntityLiving.getEyeHeight() * 0.5D - this.posY;
        	double var6 = par1EntityLiving.posZ - this.posZ;
        	this.motionX = var2 * 0.5F;
        	this.motionY = var4 * 0.5F;
        	this.motionZ = var6 * 0.5F;

        	double var10 = (double)((this.width + par1EntityLiving.width + 1.0D) * (this.width + par1EntityLiving.width + 1.0D));
        	if (this.getDistanceSq(par1EntityLiving.posX, par1EntityLiving.posY, par1EntityLiving.posZ) < var10)
        	{
        		if (this.getHeldItem() != null)
        		{
        			this.swingItem();
        		}
        		if (this.attackEntityAsMob(par1EntityLiving))
        		{
        			double var1 = (this.rand.nextInt(3) - 1) * 1.0D;
        			double var3 = (this.rand.nextInt(3) - 1) * 1.0D;
        			double var5 = (this.rand.nextInt(3) - 1) * 1.0D;
        			double var7 = (double)MathHelper.sqrt_double(var1 * var1 + var3 * var3 + var5 * var5);
        			if (var7 > 0.0F)
        			{
        				par1EntityLiving.addVelocity(var1 / var7, var3 / var7, var7 / var7);
        			}
        		}
        		this.setSoulGemDamage(1);
        		return 8;
            }
        }
        return par2;
    }

    @Override
    public int longRangeAttack(EntityLiving par1EntityLiving, int par2)
    {
        if (par2 <= 0)
        {
        	for (int var0 = 0; var0 < 4; var0++)
        	{
        		EntitySpear var1 = new EntitySpear(this.worldObj, this, par1EntityLiving, 2.0F, 6.0F);
        		int var2 = EnchantmentHelper.getEnchantmentLevel(Enchantment.sharpness.effectId, this.getHeldItem()) + EnchantmentHelper.getEnchantmentLevel(Enchantment.smite.effectId, this.getHeldItem()) + EnchantmentHelper.getEnchantmentLevel(Enchantment.baneOfArthropods.effectId, this.getHeldItem()) + 3;
        		int var3 = EnchantmentHelper.getEnchantmentLevel(Enchantment.knockback.effectId, this.getHeldItem());
        		int var4 = EnchantmentHelper.getEnchantmentLevel(Enchantment.fireAspect.effectId, this.getHeldItem());

        		if (var2 > 0)
        		{
        			var1.setDamage(var1.getDamage() + (double)var2 * 0.5D + 0.5D);
        		}
        		if (var3 > 0)
        		{
        			var1.setKnockbackStrength(var3);
        		}
        		if (var4 > 0)
        		{
        			var1.setFire(100);
        		}

        		this.worldObj.playSoundAtEntity(par1EntityLiving, "random.bow", 1.0F, 1.0F / (this.getRNG().nextFloat() * 0.4F + 0.8F));
        		this.worldObj.spawnEntityInWorld(var1);
        	}
        	if (this.rapidFire < 5)
        	{
        		this.rapidFire++;
        		return 5;
        	}
        	else
        	{
        		this.setSoulGemDamage(1);
        		this.rapidFire = 0;
        		return 12;
        	}
        }
        return par2;
    }
}