package PuellaMagi.mods;

import java.util.List;

import net.minecraft.entity.Entity;
import net.minecraft.entity.ai.EntityAIBase;
import net.minecraft.entity.ai.RandomPositionGenerator;
import net.minecraft.entity.item.EntityTNTPrimed;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.pathfinding.PathEntity;
import net.minecraft.pathfinding.PathNavigate;
import net.minecraft.util.Vec3;

public class EntityMadomagiAIAvoidEntity extends EntityAIBase
{
    private EntityMadomagi theHost;
    private float farSpeed;
    private float nearSpeed;
    private Entity closestLivingEntity;
    private float distanceFromEntity;

    private PathEntity entityPathEntity;

    private PathNavigate entityPathNavigate;

    private Class targetEntityClass;

    public EntityMadomagiAIAvoidEntity(EntityMadomagi par1EntityMadomagi, Class par2Class, float par3, float par4, float par5)
    {
        this.theHost = par1EntityMadomagi;
        this.targetEntityClass = par2Class;
        this.distanceFromEntity = par3;
        this.farSpeed = par4;
        this.nearSpeed = par5;
        this.entityPathNavigate = par1EntityMadomagi.getNavigator();
        this.setMutexBits(1);
    }

    @Override
    public boolean shouldExecute()
    {
        if (this.targetEntityClass == EntityPlayer.class)
        {
            if (this.theHost.isEnable())
            {
                return false;
            }
            this.closestLivingEntity = this.theHost.worldObj.getClosestPlayerToEntity(this.theHost, (double)this.distanceFromEntity);
            if (this.closestLivingEntity == null)
            {
                return false;
            }
        }
        else
        {
            List var1 = this.theHost.worldObj.getEntitiesWithinAABB(this.targetEntityClass, this.theHost.boundingBox.expand((double)this.distanceFromEntity, 4.0D, (double)this.distanceFromEntity));
            if (var1.isEmpty())
            {
                return false;
            }
            this.closestLivingEntity = (Entity)var1.get(0);
        }

        if (!this.theHost.getEntitySenses().canSee(this.closestLivingEntity) && this.targetEntityClass != EntityTNTPrimed.class)
        {
            return false;
        }
        else
        {
            Vec3 var2 = RandomPositionGenerator.findRandomTargetBlockAwayFrom(this.theHost, 16, 7, this.theHost.worldObj.getWorldVec3Pool().getVecFromPool(this.closestLivingEntity.posX, this.closestLivingEntity.posY, this.closestLivingEntity.posZ));

            if (var2 == null)
            {
                return false;
            }
            else if (this.closestLivingEntity.getDistanceSq(var2.xCoord, var2.yCoord, var2.zCoord) < this.closestLivingEntity.getDistanceSqToEntity(this.theHost))
            {
                return false;
            }
            else
            {
                this.entityPathEntity = this.entityPathNavigate.getPathToXYZ(var2.xCoord, var2.yCoord, var2.zCoord);
                return this.entityPathEntity == null ? false : this.entityPathEntity.isDestinationSame(var2);
            }
        }
    }

    @Override
    public boolean continueExecuting()
    {
        return !this.entityPathNavigate.noPath();
    }

    @Override
    public void startExecuting()
    {
        this.entityPathNavigate.setPath(this.entityPathEntity, this.farSpeed);
    }

    @Override
    public void resetTask()
    {
        this.closestLivingEntity = null;
    }

    @Override
    public void updateTask()
    {
        if (this.theHost.getDistanceSqToEntity(this.closestLivingEntity) < 81.0D)
        {
            this.theHost.getNavigator().setSpeed(this.nearSpeed);
        }
        else
        {
            this.theHost.getNavigator().setSpeed(this.farSpeed);
        }
    }
}