package PuellaMagi.mods;

import net.minecraft.entity.ai.EntityAIBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.pathfinding.PathNavigate;
import net.minecraft.util.MathHelper;
import net.minecraft.world.World;

public class EntityMadomagiAIFollowOwner extends EntityAIBase
{
    private EntityMadomagi thePet;
    private EntityPlayer theOwner;
    private World theWorld;
    private float field_75336_f;
    private PathNavigate petPathfinder;
    private int field_75343_h;
    private float Distance;
    private float maxDist;
    private float minDist;
    private boolean field_75344_i;

    public EntityMadomagiAIFollowOwner(EntityMadomagi par1EntityMadomagi, float par2, float par3)
    {
        this.thePet = par1EntityMadomagi;
        this.theWorld = par1EntityMadomagi.worldObj;
        this.field_75336_f = par2;
        this.petPathfinder = par1EntityMadomagi.getNavigator();
        this.Distance = par3;
        this.setMutexBits(3);
    }

    @Override
    public boolean shouldExecute()
    {
        EntityPlayer var1 = thePet.getOwner();

        if (var1 == null)
        {
        	return false;
        }
        else if (this.thePet.isStandbyMode())
        {
        	return false;
        }
        else
        {
        	if (this.thePet.isFreeMode())
        	{
        		this.minDist = this.Distance * 4.0F + 6.0F;
        		this.maxDist = this.Distance * 2.0F;
        	}
        	else
        	{
        		this.minDist = this.Distance * 2.0F + 3.0F;
        		this.maxDist = this.Distance + 1.0F;
        	}

        	if (this.thePet.getDistanceSqToEntity(var1) < (double)(this.minDist * this.minDist))
        	{
        		return false;
        	}
        	else
        	{
        		this.theOwner = var1;
        		return true;
        	}
        }
    }

    @Override
    public boolean continueExecuting()
    {
        return !this.petPathfinder.noPath() && this.thePet.getDistanceSqToEntity(this.theOwner) > (double)(this.maxDist * this.maxDist) && !this.thePet.isStandbyMode();
    }

    @Override
    public void startExecuting()
    {
        field_75343_h = 0;
        field_75344_i = this.thePet.getNavigator().getAvoidsWater();
        this.thePet.getNavigator().setAvoidsWater(false);
    }

    @Override
    public void resetTask()
    {
        this.theOwner = null;
        this.petPathfinder.clearPathEntity();
        this.thePet.getNavigator().setAvoidsWater(field_75344_i);
    }

    @Override
    public void updateTask()
    {
        this.thePet.getLookHelper().setLookPositionWithEntity(this.theOwner, 10.0F, (float)this.thePet.getVerticalFaceSpeed());

        if (!this.thePet.isStandbyMode())
        {
        	if (--this.field_75343_h <= 0)
        	{
        		this.field_75343_h = 10;

        		if (!this.petPathfinder.tryMoveToEntityLiving(this.theOwner, this.field_75336_f))
        		{
        			if (this.thePet.getDistanceSqToEntity(this.theOwner) >= 144.0D)
        			{
        				int var1 = MathHelper.floor_double(this.theOwner.posX) - 2;
        				int var2 = MathHelper.floor_double(this.theOwner.posZ) - 2;
        				int var3 = MathHelper.floor_double(this.theOwner.boundingBox.minY);

        				for (int var4 = 0; var4 <= 4; ++var4)
        				{
        					for (int var5 = 0; var5 <= 4; ++var5)
        					{
        						if ((var4 < 1 || var5 < 1 || var4 > 3 || var5 > 3) && this.theWorld.doesBlockHaveSolidTopSurface(var1 + var4, var3 - 1, var2 + var5) && !this.theWorld.isBlockNormalCube(var1 + var4, var3, var2 + var5) && !this.theWorld.isBlockNormalCube(var1 + var4, var3 + 1, var2 + var5))
        						{
        							this.thePet.setLocationAndAngles((double)((float)(var1 + var4) + 0.5F), (double)var3, (double)((float)(var2 + var5) + 0.5F), this.thePet.rotationYaw, this.thePet.rotationPitch);
        							this.petPathfinder.clearPathEntity();
        							return;
        						}
        					}
        				}
        			}
        		}
        	}
        }
    }
}