package PuellaMagi.mods;

import net.minecraft.entity.EntityLiving;
import net.minecraft.entity.ai.EntityAIBase;
import net.minecraft.item.ItemStack;
import net.minecraft.pathfinding.PathEntity;

public class EntityMadomagiAIMiddleRangeAttack extends EntityAIBase
{
    private EntityMahoShojo theHost;
    private EntityLiving theTarget;

    private int attackTick;
    private float moveSpeed;

    private PathEntity entityPathEntity;
    private int moveTick;
    private float killingRange;

    private ItemStack weapon;

    public EntityMadomagiAIMiddleRangeAttack(EntityMahoShojo par1EntityMahoShojo, float par2, float par3, ItemStack par4ItemStack)
    {
        this.theHost = par1EntityMahoShojo;
        this.moveSpeed = par2;
        this.killingRange = par3 * par3;
        this.weapon = par4ItemStack;
        this.setMutexBits(3);
    }

    @Override
    public boolean shouldExecute()
    {
        EntityLiving var1 = this.theHost.getAttackTarget();

        if (var1 == null)
        {
        	return false;
        }
        else if (this.theHost.getDistanceSq(var1.posX, var1.posY, var1.posZ) > this.killingRange)
        {
        	return false;
        }
        else if (!this.theHost.isEnable())
        {
        	return false;
        }
        else if (this.theHost.isStandbyMode())
        {
        	return false;
        }
        else if (!this.theHost.isTransformation())
        {
        	return false;
        }
        else
        {
        	this.theTarget = var1;
        	return true;
        }
    }

    @Override
    public boolean continueExecuting()
    {
        EntityLiving var1 = this.theHost.getAttackTarget();

        if (var1 == null)
        {
        	return false;
        }
        else if (!this.theTarget.isEntityAlive())
        {
        	return false;
        }
        else if (this.moveTick == 0 && this.theHost.getNavigator().getPathToEntityLiving(theTarget) != null)
        {
        	return false;
        }
        else
        {
        	return super.continueExecuting();
        }
    }

    @Override
    public void startExecuting()
    {
        this.attackTick = this.theHost.getActionTick();
        this.moveTick = 20;
        this.theHost.setCurrentItemOrArmor(0, this.weapon);
        this.theHost.enchantWeapon();
    }

    @Override
    public void resetTask()
    {
        this.theTarget = null;
        this.theHost.setAttackTarget(null);
        this.theHost.getNavigator().clearPathEntity();
        this.theHost.setCurrentItemOrArmor(0, (ItemStack)null);
        this.theHost.setPosture(false);
    }

    @Override
    public void updateTask()
    {
        boolean var1 = this.theHost.getEntitySenses().canSee(this.theTarget);

        if (var1)
        {
        	++this.moveTick;
        }
        else
        {
        	this.moveTick = 0;
        }

        if (this.moveTick >= 20)
        {
        	this.theHost.getNavigator().clearPathEntity();
        }
        else
        {
        	this.theHost.getNavigator().tryMoveToEntityLiving(this.theTarget, this.moveSpeed);
        }

        this.theHost.getLookHelper().setLookPositionWithEntity(this.theTarget, 30.0F, 30.0F);

        this.attackTick = Math.max(this.theHost.getActionTick() - 1, 0);
        if (var1)
        {
        	this.attackTick = this.theHost.middleRangeAttack(theTarget, attackTick);
        }
        this.theHost.setActionTick(this.attackTick);
    }
}