package PuellaMagi.mods;

import net.minecraft.entity.EntityLiving;
import net.minecraft.entity.ai.EntityAIBase;
import net.minecraft.item.ItemStack;
import net.minecraft.pathfinding.PathEntity;

public class EntityMadomagiAIShortRangeAttack extends EntityAIBase
{
    private EntityMahoShojo theHost;
    private EntityLiving theTarget;

    private float moveSpeed;

    private PathEntity entityPathEntity;
    private int moveTick;
    private float killingRange;

    private ItemStack weapon;

    public EntityMadomagiAIShortRangeAttack(EntityMahoShojo par1EntityMahoShojo, float par2, float par3, ItemStack par4ItemStack)
    {
        this.theHost = par1EntityMahoShojo;
        this.moveSpeed = par2;
        this.killingRange = par3 * par3;
        this.weapon = par4ItemStack;
        this.setMutexBits(3);
    }

    @Override
    public boolean shouldExecute()
    {
        EntityLiving var1 = this.theHost.getAttackTarget();

        if (var1 == null)
        {
        	if (this.theHost.getActionTick() > 0)
        	{
        		this.theHost.setActionTick(this.theHost.getActionTick() - 1);
        	}
        	return false;
        }
        else if (this.theHost.getDistanceSq(var1.posX, var1.posY, var1.posZ) > this.killingRange)
        {
        	return false;
        }
        else if (!this.theHost.isEnable())
        {
        	return false;
        }
        else if (this.theHost.isStandbyMode())
        {
        	return false;
        }
        else if (!this.theHost.isTransformation())
        {
        	return false;
        }
        else
        {
        	this.theTarget = var1;
        	this.entityPathEntity = this.theHost.getNavigator().getPathToEntityLiving(this.theTarget);
        	return this.entityPathEntity != null;
        }
    }

    @Override
    public boolean continueExecuting()
    {
        EntityLiving var1 = this.theHost.getAttackTarget();
        if (var1 == null)
        {
        	return false;
        }
        else if (!this.theTarget.isEntityAlive())
        {
        	return false;
        }
        else if (this.theHost.getDistanceSq(this.theTarget.posX, this.theTarget.posY, this.theTarget.posZ) > this.killingRange)
        {
        	return false;
        }
        else
        {
        	return this.theHost.getNavigator().getPathToEntityLiving(theTarget) != null;
        }
    }

    @Override
    public void startExecuting()
    {
        this.theHost.setActionTick(0);
        this.theHost.getNavigator().setPath(this.entityPathEntity, this.moveSpeed);
        this.moveTick = 0;
        this.theHost.setCurrentItemOrArmor(0, this.weapon);
        this.theHost.enchantWeapon();
    }

    @Override
    public void resetTask()
    {
        this.theTarget = null;
        this.theHost.setAttackTarget(null);
        this.theHost.getNavigator().clearPathEntity();
        this.theHost.setCurrentItemOrArmor(0, (ItemStack)null);
        this.theHost.setPosture(false);
    }

    @Override
    public void updateTask()
    {
        this.theHost.getLookHelper().setLookPositionWithEntity(this.theTarget, 30.0F, 30.0F);

        if (this.theHost.getEntitySenses().canSee(this.theTarget) && --this.moveTick <= 0)
        {
        	this.moveTick = 4 + this.theHost.getRNG().nextInt(7);
        	this.theHost.getNavigator().tryMoveToEntityLiving(this.theTarget, this.moveSpeed);
        }

        this.theHost.setActionTick(this.theHost.shortRangeAttack(theTarget, Math.max(this.theHost.getActionTick() - 1, 0)));
    }
}