package PuellaMagi.mods;

import net.minecraft.entity.monster.EntityMob;
import net.minecraft.world.World;

public abstract class EntityMajo extends EntityMob
{
    private int age;
    private int summonServant;

    public EntityMajo(World par1World)
    {
        super(par1World);
        this.age = 0;
        this.summonServant = 0;
    }

    @Override
    protected void fall(float par1) {}

    @Override
    public void onLivingUpdate()
    {
        super.onLivingUpdate();
        this.age++;
        if (this.age > 2000 && this.getAdvance() != null)
        {
        	EntityMajo var1 = this.getAdvance();
        	if (this.advanceMajo(var1))
        	{
        		var1.spawnExplosionParticle();
        		this.setDead();
        	}
        }
        else if (this.age > 200 && this.getServant() != null)
        {
        	EntityMajo var1 = this.getServant();
        	if (this.canSummonServant(var1))
        	{
        		var1.spawnExplosionParticle();
        		this.summonServant++;
        		if (this.summonServant > 5)
        		{
        			this.age = 0;
        			this.summonServant = 0;
        		}
        	}
        }
    }

    @Override
    protected boolean isAIEnabled()
    {
        return true;
    }

    @Override
    public boolean getCanSpawnHere()
    {
        return this.worldObj.difficultySetting > 0 && this.worldObj.getCollidingBoundingBoxes(this, this.boundingBox).isEmpty() && !this.worldObj.isAnyLiquid(this.boundingBox);
    }

    private boolean spawnMajo(EntityMajo par1EntityMajo)
    {
        if (par1EntityMajo.getCanSpawnHere())
        {
        	if (!this.worldObj.isRemote)
        	{
        		this.worldObj.spawnEntityInWorld(par1EntityMajo);
        	}
        	return true;
        }
        return false;
    }

    protected EntityMajo getAdvance()
    {
        return null;
    }

    private boolean advanceMajo(EntityMajo par1EntityMajo)
    {
        par1EntityMajo.setLocationAndAngles(this.posX, this.posY, this.posZ, this.rotationPitch, 0.0F);
        return this.spawnMajo(par1EntityMajo);
    }

    protected EntityMajo getServant()
    {
        return null;
    }

    private boolean canSummonServant(EntityMajo par1EntityMajo)
    {
        int var1 = this.worldObj.getEntitiesWithinAABB(EntityMajo.class, this.boundingBox.expand(8.0D, 4.0D, 8.0D)).size();
        if (var1 >= 6)
        {
        	return false;
        }
        par1EntityMajo.setLocationAndAngles(this.posX + (this.rand.nextDouble() - 0.5D) * 8.0D, this.posY + (this.rand.nextDouble() - 0.5D) * 8.0D, this.posZ + (this.rand.nextDouble() - 0.5D) * 8.0D, this.rand.nextFloat() * 360.0F, 0.0F);
        return this.spawnMajo(par1EntityMajo);
    }
}