package PuellaMagi.mods;

import java.util.Iterator;
import java.util.List;

import net.minecraft.command.IEntitySelector;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLiving;
import net.minecraft.entity.ai.EntityAIBase;
import net.minecraft.pathfinding.PathEntity;
import net.minecraft.util.MathHelper;

public class EntityMajoAIShadowPuellaMagiAttack extends EntityAIBase
{
    private EntityShadowPuellaMagi theHost;
    private EntityLiving theTarget;

    private int attackTick;
    private float moveSpeed;

    private PathEntity entityPathEntity;
    private int moveTick;
    private float killingRange;

    private int puellaMagiType;
    private int rapidFire;

    public EntityMajoAIShadowPuellaMagiAttack(EntityShadowPuellaMagi par1EntityShadowPuellaMagi, float par2, float par3)
    {
        this.theHost = par1EntityShadowPuellaMagi;
        this.attackTick = 0;
        this.moveSpeed = par2;
        this.killingRange = par3 * par3;
        this.rapidFire = 0;
        this.puellaMagiType = -1;
        this.setMutexBits(3);
    }

    @Override
    public boolean shouldExecute()
    {
        EntityLiving var1 = this.theHost.getAttackTarget();
        this.puellaMagiType = this.theHost.getPuellaMagiType();

        if (var1 == null)
        {
        	return false;
        }
        if (this.puellaMagiType == -1)
        {
        	return false;
        }
        else
        {
        	this.theTarget = var1;
        	return true;
        }
    }

    @Override
    public boolean continueExecuting()
    {
        return this.shouldExecute() || !this.theHost.getNavigator().noPath();
    }

    @Override
    public void startExecuting()
    {
        this.moveTick = 20;
        this.theHost.setCurrentItemOrArmor(0, this.theHost.getWeapon(this.puellaMagiType));
    }

    @Override
    public void resetTask()
    {
        this.theTarget = null;
    }

    @Override
    public void updateTask()
    {
        boolean var1 = this.theHost.getEntitySenses().canSee(this.theTarget);
        double var3 = this.theHost.getDistanceSq(this.theTarget.posX, this.theTarget.boundingBox.minY, this.theTarget.posZ);

        if (var1)
        {
        	++this.moveTick;
        }
        else
        {
        	this.moveTick = 0;
        }

        if (var3 <= this.killingRange && this.moveTick >= 20)
        {
        	this.theHost.getNavigator().clearPathEntity();
        }
        else
        {
        	this.theHost.getNavigator().tryMoveToEntityLiving(this.theTarget, this.moveSpeed);
        }

        this.theHost.getLookHelper().setLookPositionWithEntity(this.theTarget, 30.0F, 30.0F);
        this.attackTick = Math.max(this.attackTick - 1, 0);

        if (var1 && this.attackTick <= 0)
        {
        	this.attack(this.puellaMagiType, this.theTarget);
        }
    }

    private void attack(int par1, EntityLiving par2EntityLiving)
    {
        if (par1 == 0)
        {
        	EntityLightArrow var2 = new EntityLightArrow(this.theHost.worldObj, this.theHost, par2EntityLiving, 1.6F, 6.0F);
        	this.theHost.worldObj.playSoundAtEntity(this.theHost, "random.bow", 1.0F, 1.0F / (this.theHost.getRNG().nextFloat() * 0.4F + 0.8F));
        	this.theHost.worldObj.spawnEntityInWorld(var2);
        	if (this.rapidFire < 3)
        	{
        		this.rapidFire++;
        		this.attackTick = 3;
        	}
        	else
        	{
        		this.rapidFire = 0;
        		this.attackTick = 20;
        	}
        }
        else if (par1 == 1)
        {
        	EntityMadomagiBullet var2 = new EntityMadomagiBullet(this.theHost.worldObj, this.theHost, par2EntityLiving, 1.6F, 12.0F);
        	this.theHost.worldObj.playSoundAtEntity(this.theHost, "random.bow", 1.0F, 1.0F / (this.theHost.getRNG().nextFloat() * 0.4F + 0.8F));
        	this.theHost.worldObj.spawnEntityInWorld(var2);
        	if (this.rapidFire < 5)
        	{
        		this.rapidFire++;
        		this.attackTick = 2;
        	}
        	else
        	{
        		this.rapidFire = 0;
        		this.attackTick = 20;
        	}
        }
        else if (par1 == 2)
        {
        	double var2 = par2EntityLiving.posX - this.theHost.posX;
        	double var4 = par2EntityLiving.posY + (double)par2EntityLiving.getEyeHeight() * 0.5D - this.theHost.posY;
        	double var6 = par2EntityLiving.posZ - this.theHost.posZ;
        	this.theHost.motionX = var2 * 0.5F;
        	this.theHost.motionY = var4 * 0.5F;
        	this.theHost.motionZ = var6 * 0.5F;

        	double var10 = (double)((this.theHost.width + par2EntityLiving.width) * (this.theHost.width + par2EntityLiving.width));
        	if (this.theHost.getDistanceSq(par2EntityLiving.posX, par2EntityLiving.posY, par2EntityLiving.posZ) < var10)
        	{
        		if (this.theHost.getHeldItem() != null)
        		{
        			this.theHost.swingItem();
        		}
        		this.theHost.attackEntityAsMob(par2EntityLiving);
        		this.attackTick = 20;
        	}
        }
        else if (par1 == 3)
        {
        	if (this.checkMusket())
        	{
        		EntityMadomagiBullet var2 = new EntityMadomagiBullet(this.theHost.worldObj, this.theHost, par2EntityLiving, 2.0F, 1.2F);
        		this.theHost.worldObj.playSoundAtEntity(this.theHost, "random.bow", 1.0F, 1.0F / (this.theHost.getRNG().nextFloat() * 0.4F + 0.8F));
        		this.theHost.worldObj.spawnEntityInWorld(var2);
        		this.attackTick = 3;
        	}
        	else if (this.theHost.getNavigator().noPath())
        	{
        		for (int var0 = 0; var0 < 4; var0++)
        		{
        			float var3 = this.theHost.getRNG().nextFloat() * (float)Math.PI * 2.0F;
        			EntityMusket var4 = new EntityMusket(this.theHost.worldObj, this.theHost.posX + (double)MathHelper.cos(var3), this.theHost.posY + this.theHost.getEyeHeight(), this.theHost.posZ + (double)MathHelper.sin(var3));
        			this.theHost.worldObj.spawnEntityInWorld(var4);
        		}
        		this.attackTick = 10;
        	}
        }
        else if (par1 == 4)
        {
        	double var2 = par2EntityLiving.posX - this.theHost.posX;
        	double var4 = par2EntityLiving.posY + (double)par2EntityLiving.getEyeHeight() * 0.5D - this.theHost.posY;
        	double var6 = par2EntityLiving.posZ - this.theHost.posZ;
        	this.theHost.motionX = var2 * 0.5F;
        	this.theHost.motionY = var4 * 0.5F;
        	this.theHost.motionZ = var6 * 0.5F;

        	double var10 = (double)((this.theHost.width + par2EntityLiving.width) * (this.theHost.width + par2EntityLiving.width));
        	if (this.theHost.getDistanceSq(par2EntityLiving.posX, par2EntityLiving.posY, par2EntityLiving.posZ) < var10)
        	{
        		if (this.theHost.getHeldItem() != null)
        		{
        			this.theHost.swingItem();
        		}
        		if (this.theHost.attackEntityAsMob(par2EntityLiving))
        		{
        			double var1 = this.theHost.getRNG().nextInt(3) - 1;
        			double var3 = this.theHost.getRNG().nextInt(3) - 1;
        			double var5 = this.theHost.getRNG().nextInt(3) - 1;
        			double var7 = (double)MathHelper.sqrt_double(var1 * var1 + var3 * var3 + var5 * var5);
        			if (var7 > 0.0F)
        			{
        				par2EntityLiving.addVelocity(var1 / var7, var3 / var7, var7 / var7);
        			}
        		}
        		this.attackTick = 20;
            }
        }
    }

    private boolean checkMusket()
    {
        List var1 = this.theHost.worldObj.selectEntitiesWithinAABB(EntityMusket.class, this.theHost.boundingBox.expand(3.0D, 3.0D, 3.0D), (IEntitySelector)null);
        Iterator var2 = var1.iterator();
        while (var2.hasNext())
        {
        	Entity var3 = (Entity)var2.next();
        	var3.setDead();
        	return true;
        }
        return false;
    }
}