package PuellaMagi.mods;

import java.util.LinkedList;

import net.minecraft.entity.EntityLiving;
import net.minecraft.entity.ai.EntityAIBase;
import net.minecraft.util.MathHelper;

public class EntityMajoAIWalpurgisnachtPlay extends EntityAIBase
{
    private EntityWalpurgisnacht entityHost;
    private EntityLiving entityTarget;
    private double xPosition;
    private double yPosition;
    private double zPosition;
    private float moveSpeed;
    private int moveTick;
    private int attackTick;
    private LinkedList TNTsettingList;
    private int xTarget;
    private int yTarget;
    private int zTarget;
    private int attackTime1;
    private int attackTime2;

    public EntityMajoAIWalpurgisnachtPlay(EntityWalpurgisnacht par1EntityWalpurgisnacht, float par2)
    {
        this.entityHost = par1EntityWalpurgisnacht;
        this.moveSpeed = par2;
        this.TNTsettingList = new LinkedList();
        this.attackTick = 500;
        this.setMutexBits(3);
    }

    @Override
    public boolean shouldExecute()
    {
        EntityLiving var1 = this.entityHost.getAttackTarget();
        if (var1 == null)
        {
        	return false;
        }
        else
        {
        	this.entityTarget = var1;
        	return true;
        }
    }

    @Override
    public void startExecuting()
    {
        this.initPosition();
        this.initMovement();
        this.moveTick = 1000;
        this.attackTime1 = 15 + this.entityHost.getRNG().nextInt(15);
        this.attackTime2 = 50 + this.entityHost.getRNG().nextInt(50);
    }

    @Override
    public void updateTask()
    {
        double var1 = this.entityHost.getDistanceSq(this.xPosition, this.yPosition, this.zPosition);
        if (var1 < 4.0D || this.moveTick-- < 0)
        {
        	this.initPosition();
        	this.moveTick = 1000;
        }
        this.initMovement();
        double var2 = this.entityTarget.posX - this.entityHost.posX;
        double var3 = this.entityTarget.posZ - this.entityHost.posZ;
        this.entityHost.rotationYaw = (float)(Math.atan2(var3, var2) * 180.0D / Math.PI) - 90.0F;
        if (++this.attackTick > 100)
        {
        	this.attackTick = 0;
        	this.entityHost.attackFlameLance(this.entityTarget, 5);
        }
        if (this.attackTick % this.attackTime1 == 0)
        {
        	this.entityHost.attackFlameLance(this.entityTarget, 1);
        	this.attackTime1 = 15 + this.entityHost.getRNG().nextInt(15);
        }
        if (this.attackTick % this.attackTime2 == 0)
        {
        	this.entityHost.attackPrickle(this.entityTarget, this.entityHost.getRNG().nextInt(1) + 1);
        	this.attackTime2 = 50 + this.entityHost.getRNG().nextInt(50);
        }
    }

    private void initPosition()
    {
        double var1;
        do
        {
        	this.xPosition = this.entityTarget.posX + (double)(this.entityHost.getRNG().nextFloat() - 0.5F) * 100.0D;
        	this.zPosition = this.entityTarget.posZ + (double)(this.entityHost.getRNG().nextFloat() - 0.5F) * 100.0D;
        	this.yPosition = this.entityTarget.posY + (double)(this.entityHost.getRNG().nextFloat() + 0.5F) * 20.0D;
        	var1 = Math.min(this.entityHost.getDistanceSq(this.xPosition, this.yPosition, this.zPosition), this.entityTarget.getDistanceSq(this.xPosition, this.yPosition, this.zPosition));
        }
        while (var1 < 225.0D);
    }

    private void initMovement()
    {
        double var1 = this.entityHost.posX - this.xPosition;
        double var2 = this.entityHost.posY - this.yPosition;
        double var3 = this.entityHost.posZ - this.zPosition;
        double var4 = MathHelper.sqrt_double(var1 * var1 + var2 * var2 + var3 * var3);
        this.entityHost.motionX = -var1 * (float)this.moveSpeed / var4;
        this.entityHost.motionY = -var2 * (float)this.moveSpeed / var4;
        this.entityHost.motionZ = -var3 * (float)this.moveSpeed / var4;
    }
}