package PuellaMagi.mods;

import net.minecraft.entity.ai.EntityAIBase;
import net.minecraft.util.MathHelper;

public class EntityMajoAIWalpurgisnachtWander extends EntityAIBase
{
    private EntityMajo entityHost;
    private double xPosition;
    private double yPosition;
    private double zPosition;
    private float moveSpeed;
    private int moveTick;

    public EntityMajoAIWalpurgisnachtWander(EntityMajo par1EntityMajo, float par2)
    {
        this.entityHost = par1EntityMajo;
        this.moveSpeed = par2;
        this.setMutexBits(1);
    }

    @Override
    public boolean shouldExecute()
    {
        if (this.entityHost.getAttackTarget() != null)
        {
        	return false;
        }
        return true;
    }

    @Override
    public void startExecuting()
    {
        this.initPosition();
        this.initMovement();
        this.moveTick = 1000;
    }

    @Override
    public void updateTask()
    {
        double var1 = this.entityHost.getDistanceSq(this.xPosition, this.yPosition, this.zPosition);
        if (var1 < 1.0D || this.moveTick-- < 0)
        {
        	this.initPosition();
        	this.moveTick = 1000;
        }
        this.initMovement();
    }

    private void initPosition()
    {
        double var1 = 0.0D;
        while (var1 < 225.0D)
        {
        	this.xPosition = this.entityHost.posX + (double)(this.entityHost.getRNG().nextFloat() -0.5F) * 100.0D;
        	this.zPosition = this.entityHost.posZ + (double)(this.entityHost.getRNG().nextFloat() -0.5F) * 100.0D;
        	this.yPosition = this.entityHost.worldObj.getHeightValue((int)this.xPosition, (int)this.zPosition) + (double)(this.entityHost.getRNG().nextFloat() + 1.0F) * 10.0D;
        	var1 = this.entityHost.getDistanceSq(this.xPosition, this.yPosition, this.zPosition);
        }
    }

    private void initMovement()
    {
        double var1 = this.xPosition - this.entityHost.posX;
        double var2 = this.yPosition - this.entityHost.posY;
        double var3 = this.zPosition - this.entityHost.posZ;
        double var4 = MathHelper.sqrt_double(var1 * var1 + var2 * var2 + var3 * var3);
        this.entityHost.motionX = var1 * (float)this.moveSpeed / var4;
        this.entityHost.motionY = var2 * (float)this.moveSpeed / var4;
        this.entityHost.motionZ = var3 * (float)this.moveSpeed / var4;
        this.entityHost.rotationYaw = (float)(Math.atan2(var3, var1) * 180.0D / Math.PI) - 90.0F;
    }
}