package PuellaMagi.mods;

import java.util.Iterator;
import java.util.List;

import net.minecraft.command.IEntitySelector;
import net.minecraft.enchantment.Enchantment;
import net.minecraft.enchantment.EnchantmentHelper;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLiving;
import net.minecraft.entity.ai.EntityAILookIdle;
import net.minecraft.entity.ai.EntityAISwimming;
import net.minecraft.entity.ai.EntityAIWander;
import net.minecraft.entity.ai.EntityAIWatchClosest;
import net.minecraft.entity.item.EntityTNTPrimed;
import net.minecraft.entity.monster.EntityMob;
import net.minecraft.entity.passive.EntityAmbientCreature;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.util.MathHelper;
import net.minecraft.world.World;

public class EntityMami extends EntityMahoShojo
{
    public EntityMami(World par1World)
    {
        super(par1World);
        this.texture = "/PuellaMagi/Mobs/mami.png";
        this.MSTexture = "/PuellaMagi/Mobs/mamiMS.png";
        this.attackStrength = 1;
        this.MSAttackStrength = 8;
        this.MSProtectStrength = 20;
        this.moveSpeed = 0.3F;
        this.soulGemID = mod_QB.mamiGem.shiftedIndex;
        ItemStack var1 = new ItemStack(mod_QB.mamiMusket);

        this.getNavigator().setAvoidsWater(true);
        this.tasks.addTask(1, new EntityAISwimming(this));
        this.tasks.addTask(2, new EntityMadomagiAIAvoidEntity(this, EntityTNTPrimed.class, 16.0F, this.moveSpeed, this.moveSpeed + 0.2F));
        this.tasks.addTask(3, new EntityMadomagiAIStandby(this));
        this.tasks.addTask(4, new EntityMadomagiAIShortRangeAttack(this, this.moveSpeed, 4.0F, var1));
        this.tasks.addTask(5, new EntityMadomagiAIMiddleRangeAttack(this, this.moveSpeed, 10.0F, var1));
        this.tasks.addTask(6, new EntityMadomagiAILongRangeAttack(this, this.moveSpeed, 15.0F, var1));
        this.tasks.addTask(6, new EntityMadomagiAITeaTime(this, new ItemStack(mod_QB.mamiTea), true, 3));
        this.tasks.addTask(7, new EntityMadomagiAIFollowOwner(this, this.moveSpeed, 1.25F));
        this.tasks.addTask(8, new EntityAIWander(this, this.moveSpeed));
        this.tasks.addTask(9, new EntityAIWatchClosest(this, EntityPlayer.class, 8.0F));
        this.tasks.addTask(9, new EntityAILookIdle(this));
        this.targetTasks.addTask(1, new EntityMadomagiAIOwnerHurtByTarget(this));
        this.targetTasks.addTask(2, new EntityMadomagiAIOwnerHurtTarget(this));
        this.targetTasks.addTask(3, new EntityMadomagiAINearestAttackableTarget(this, EntityMob.class, 16.0F, 4.0F, true));
        this.targetTasks.addTask(4, new EntityMadomagiAINearestAttackableTarget(this, EntityAmbientCreature.class, 16.0F, 4.0F, true));
    }

    @Override
    public int getMaxHealth()
    {
        return 18;
    }

    @Override
    public int shortRangeAttack(EntityLiving par1EntityLiving, int par2)
    {
        double var2 = (double)((this.width + par1EntityLiving.width + 0.5D) * (this.width + par1EntityLiving.width + 0.5D));
        if (this.getDistanceSq(par1EntityLiving.posX, par1EntityLiving.posY, par1EntityLiving.posZ) < var2)
        {
        	if (par2 <= 0)
        	{
        		if (this.getHeldItem() != null)
        		{
        			this.swingItem();
        		}
        		this.attackEntityAsMob(par1EntityLiving);
        		par1EntityLiving.addVelocity((double)(-MathHelper.sin(this.rotationYaw * (float)Math.PI / 180.0F) * 2.0F), 0.1D, (double)(MathHelper.cos(this.rotationYaw * (float)Math.PI / 180.0F) * 2.0F));
            	this.chatMessage("Gambe d'oro!");
        		this.setSoulGemDamage(1);
        	}
        }
        return par2;
    }

    @Override
    public int middleRangeAttack(EntityLiving par1EntityLiving, int par2)
    {
        if (!this.isPosture())
        {
        	this.setPosture(true);
        }

        if (par2 <= 0)
        {
        	if (this.checkMusket())
        	{
        		this.mamiShot(par1EntityLiving, 1.6F, 1.2F, 5, 0, 0, false);
        		return 3;
        	}
        	else if (this.getNavigator().noPath())
        	{
        		for (int var0 = 0; var0 < 4; var0++)
        		{
        			float var3 = this.rand.nextFloat() * (float)Math.PI * 2.0F;
        			EntityMusket var4 = new EntityMusket(this.worldObj, this.posX + (double)MathHelper.cos(var3), this.posY + this.getEyeHeight(), this.posZ + (double)MathHelper.sin(var3));
        			this.worldObj.spawnEntityInWorld(var4);
        		}
        		this.setSoulGemDamage(1);
        		this.chatMessage("Danza del Magic Bullet!");
        		return 3;
        	}
        }
        return par2;
    }

    @Override
    public int longRangeAttack(EntityLiving par1EntityLiving, int par2)
    {
        if (!this.isPosture())
        {
        	this.setPosture(true);
        }

        if (par2 <= 0)
        {
        	if (par1EntityLiving.getHealth() < 10)
        	{
        		if (par1EntityLiving.getMaxHealth() > 30)
        		{
        			this.mamiShot(par1EntityLiving, 1.6F, 0.0F, 0, 1, 0, true);
        			this.chatMessage("Tiro Finale!");
        			this.setSoulGemDamage(1);
        			return 30;
        		}
        		else
        		{
        			this.mamiShot(par1EntityLiving, 1.6F, 1.2F, 20, 1, 0, false);
        			this.chatMessage("Tiro!");
        			return 5;
        		}
        	}
        	else
        	{
        		if (this.checkMusket())
        		{
        			this.mamiShot(par1EntityLiving, 1.6F, 1.2F, 5, 0, 0, false);
        			return 3;
        		}
        		else if (this.getNavigator().noPath())
        		{
        			for (int var0 = 0; var0 < 12; var0++)
        			{
        				float var3 = this.rand.nextFloat() * (float)Math.PI * 2.0F;
        				EntityMusket var4 = new EntityMusket(this.worldObj, this.posX + (double)MathHelper.cos(var3), this.posY + this.getEyeHeight(), this.posZ + (double)MathHelper.sin(var3));
        				this.worldObj.spawnEntityInWorld(var4);
        			}
        			this.setSoulGemDamage(1);
        			this.chatMessage("Danza del Magic Bullet!");
        			return 10;
        		}
        	}
        }
        return par2;
    }

    private void mamiShot(EntityLiving par1EntityLiving, float par2, float par3, int par4, int par5, int par6, boolean par7)
    {
        EntityMadomagiBullet var2 = new EntityMadomagiBullet(this.worldObj, this, par1EntityLiving, par2, par3);
        int var3 = EnchantmentHelper.getEnchantmentLevel(Enchantment.power.effectId, this.getHeldItem()) + par4;
        int var4 = EnchantmentHelper.getEnchantmentLevel(Enchantment.punch.effectId, this.getHeldItem()) + par5;
        int var5 = EnchantmentHelper.getEnchantmentLevel(Enchantment.flame.effectId, this.getHeldItem()) + par6;

        if (var3 > 0)
        {
        	var2.setDamagePower(var2.getDamagePower() + (double)var3 * 0.5D + 0.5D);
        }
        if (var4 > 0)
        {
        	var2.setKnockbackStrength(var4);
        }
        if (var5 > 0)
        {
        	var2.setFire(100);
        }
        if (par7)
        {
        	var2.setTiro();
        }

        this.worldObj.playSoundAtEntity(this, "random.bow", 1.0F, 1.0F / (this.getRNG().nextFloat() * 0.4F + 0.8F));
        this.worldObj.spawnEntityInWorld(var2);
    }

    public boolean checkMusket()
    {
        List var1 = this.worldObj.selectEntitiesWithinAABB(EntityMusket.class, this.boundingBox.expand(3.0D, 3.0D, 3.0D), (IEntitySelector)null);
        Iterator var2 = var1.iterator();
        while (var2.hasNext())
        {
        	Entity var3 = (Entity)var2.next();
        	var3.setDead();
        	return true;
        }
        return false;
    }
}