package PuellaMagi.mods;

import net.minecraft.block.Block;
import net.minecraft.entity.ai.EntityAILookIdle;
import net.minecraft.entity.ai.EntityAISwimming;
import net.minecraft.entity.ai.EntityAIWander;
import net.minecraft.entity.ai.EntityAIWatchClosest;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.MathHelper;
import net.minecraft.world.World;

public class EntityQB extends EntityMadomagi
{
    public EntityQB(World par1World)
    {
        super(par1World);
        this.texture = "/PuellaMagi/Mobs/qb.png";
        this.setSize(0.6F, 0.8F);
        this.moveSpeed = 0.3F;

        this.getNavigator().setAvoidsWater(true);
        this.tasks.addTask(1, new EntityAISwimming(this));
        this.tasks.addTask(2, new EntityMadomagiAIAvoidEntity(this, EntityPlayer.class, 16.0F, 0.18F, 0.4F));
        this.tasks.addTask(3, new EntityMadomagiAIStandby(this));
        this.tasks.addTask(7, new EntityAIWander(this, this.moveSpeed));
        this.tasks.addTask(6, new EntityMadomagiAIFollowOwner(this, this.moveSpeed, 0.75F));
        this.tasks.addTask(8, new EntityAIWatchClosest(this, EntityPlayer.class, 8.0F));
        this.tasks.addTask(8, new EntityAILookIdle(this));
    }

    @Override
    public void updateAITick()
    {
        if (this.getMoveHelper().func_75640_a())
        {
        	float var1 = this.getMoveHelper().getSpeed();
        	if (var1 == 0.18F)
        	{
        		this.setSneaking(true);
        		this.setSprinting(false);
        	}
        	else if (var1 == 0.4F)
        	{
        		this.setSneaking(false);
        		this.setSprinting(true);
        	}
        	else
        	{
        		this.setSneaking(false);
        		this.setSprinting(false);
        	}
        }
        else
        {
        	this.setSneaking(false);
        	this.setSprinting(false);
        }
    }

    @Override
    public int getMaxHealth()
    {
        return 10;
    }

    @Override
    protected void fall(float par1) {}

    @Override
    public boolean interact(EntityPlayer par1EntityPlayer)
    {
        ItemStack var1 = par1EntityPlayer.inventory.getCurrentItem();
        if ( var1 != null && this.isEnable())
        {
        	if (var1.itemID == mod_QB.itemGriefSeed.shiftedIndex)
        	{
        		ItemStack var2 = this.chooseItem(var1);
        		if (!par1EntityPlayer.capabilities.isCreativeMode)
        		{
        			--var1.stackSize;
        		}
        		if (var1.stackSize <= 0)
        		{
        			par1EntityPlayer.inventory.setInventorySlotContents(par1EntityPlayer.inventory.currentItem, (ItemStack)null);
        		}
        		if (!this.worldObj.isRemote)
        		{
        			this.entityDropItem(var2, 1);
        		}
        		return true;
        	}
        }
        return super.interact(par1EntityPlayer);
    }

    public ItemStack chooseItem(ItemStack par1ItemStack)
    {
    	int var1;
    	int var2;
    	int var3 = 1;
    	if (par1ItemStack.getItemDamage() == 0)
    	{
    		var1 = this.rand.nextInt(5);
    		switch (var1)
    		{
    			case 0:
    				var2 = mod_QB.madokaGem.shiftedIndex;
    				break;

    			case 1:
    				var2 = mod_QB.homuraGem.shiftedIndex;
    				break;

    			case 2:
    				var2 = mod_QB.sayakaGem.shiftedIndex;
    				break;

    			case 3:
    				var2 = mod_QB.mamiGem.shiftedIndex;
    				break;

    			case 4:
    				var2 = mod_QB.kyoukoGem.shiftedIndex;
    				break;

    			default:
    				return par1ItemStack;
    		}
    	}
    	else
    	{
    		var1 = this.rand.nextInt(par1ItemStack.getItemDamage());
    		if (var1 == 0)
    		{
    			var2 = mod_QB.mamiTea.shiftedIndex;
    			var3 = 6;
    		}
    		else if (var1 < 16)
    		{
    			return new ItemStack(Item.appleGold, 1, 1);
    		}
    		else if (var1 < 32)
    		{
    			var2 = Item.ingotIron.shiftedIndex;
    			var3 = 16;
    		}
    		else if (var1 < 48)
    		{
    			var2 = Item.ingotGold.shiftedIndex;
    			var3 = 4;
    		}
    		else if (var1 < 63)
    		{
    			var2 = Item.emerald.shiftedIndex;
    			var3 = 8;
    		}
    		else
    		{
				var2 = Item.diamond.shiftedIndex;
    		}
    	}
    	return new ItemStack(var2, var3, 0);
    }

    @Override
    public boolean getCanSpawnHere()
    {
        if (this.worldObj.rand.nextInt(20) != 0)
        {
        	return false;
        }
        else
        {
        	if (this.worldObj.checkIfAABBIsClear(this.boundingBox) && this.worldObj.getCollidingBoundingBoxes(this, this.boundingBox).isEmpty() && !this.worldObj.isAnyLiquid(this.boundingBox))
        	{
        		int var1 = MathHelper.floor_double(this.posX);
        		int var2 = MathHelper.floor_double(this.boundingBox.minY);
        		int var3 = MathHelper.floor_double(this.posZ);
        		if (var2 < 63)
        		{
        			return false;
        		}
        		int var4 = this.worldObj.getBlockId(var1, var2 - 1, var3);
        		if (var4 == Block.grass.blockID || var4 == Block.leaves.blockID)
        		{
        			return true;
        		}
        	}
        	return false;
        }
    }
}