package PuellaMagi.mods;

import net.minecraft.entity.Entity;
import net.minecraft.entity.ai.EntityAIHurtByTarget;
import net.minecraft.entity.ai.EntityAILookIdle;
import net.minecraft.entity.ai.EntityAINearestAttackableTarget;
import net.minecraft.entity.ai.EntityAISwimming;
import net.minecraft.entity.ai.EntityAIWander;
import net.minecraft.entity.ai.EntityAIWatchClosest;
import net.minecraft.entity.passive.EntityVillager;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.world.World;

public class EntityShadowPuellaMagi extends EntityMajo
{
    private int puellaMagiType;

    public EntityShadowPuellaMagi(World par1World)
    {
        super(par1World);
        this.setSize(0.5F, 1.5F);
        this.moveSpeed = 0.3F;
        this.puellaMagiType = this.rand.nextInt(5);

        this.tasks.addTask(0, new EntityAISwimming(this));
        this.tasks.addTask(3, new EntityMajoAIShadowPuellaMagiAttack(this, this.moveSpeed, 12.0F));
        this.tasks.addTask(6, new EntityAIWander(this, this.moveSpeed));
        this.tasks.addTask(7, new EntityAIWatchClosest(this, EntityPlayer.class, 8.0F));
        this.tasks.addTask(7, new EntityAILookIdle(this));
        this.targetTasks.addTask(0, new EntityAINearestAttackableTarget(this, EntityMahoShojo.class, 12.0F, 0, false));
        this.targetTasks.addTask(1, new EntityAINearestAttackableTarget(this, EntityVillager.class, 12.0F, 0, false));
        this.targetTasks.addTask(2, new EntityAINearestAttackableTarget(this, EntityPlayer.class, 12.0F, 0, true));
    }

    @Override
    public int getMaxHealth()
    {
        return 5;
    }

    @Override
    public String getTexture()
    {
        return "/PuellaMagi/Mobs/shadow_" + this.getPuellaMagiType() + ".png";
    }

    @Override
    protected void entityInit()
    {
        super.entityInit();
        this.dataWatcher.addObject(18, new Byte((byte)-1));
    }

    @Override
    public void onLivingUpdate()
    {
        if (!this.worldObj.isRemote && this.getPuellaMagiType() == -1)
        {
        	this.setPuellaMagiType(this.puellaMagiType);
        }
        super.onLivingUpdate();
    }

    public int getPuellaMagiType()
    {
        return this.dataWatcher.getWatchableObjectByte(18);
    }

    private void setPuellaMagiType(int par1)
    {
        this.dataWatcher.updateObject(18, Byte.valueOf((byte)par1));
    }

    @Override
    public void readEntityFromNBT(NBTTagCompound par1NBTTagCompound)
    {
        super.readEntityFromNBT(par1NBTTagCompound);

        if (par1NBTTagCompound.hasKey("PuellaMagiType"))
        {
            byte var2 = par1NBTTagCompound.getByte("PuellaMagiType");
            this.setPuellaMagiType(var2);
        }
    }

    @Override
    public void writeEntityToNBT(NBTTagCompound par1NBTTagCompound)
    {
        super.writeEntityToNBT(par1NBTTagCompound);
        par1NBTTagCompound.setByte("PuellaMagiType", (byte)this.getPuellaMagiType());
    }

    public ItemStack getWeapon(int par1)
    {
        if (par1 == 0)
        {
        	return new ItemStack(mod_QB.madokaWeapon);
        }
        else if (par1 == 1)
        {
        	return new ItemStack(mod_QB.homuraGun2);
        }
        else if (par1 == 2)
        {
        	return new ItemStack(mod_QB.sayakaCutlass);
        }
        else if (par1 == 3)
        {
        	return new ItemStack(mod_QB.mamiMusket);
        }
        else if (par1 == 4)
        {
        	return new ItemStack(mod_QB.kyoukoSpear);
        }
        return null;
    }

    @Override
    public int getAttackStrength(Entity par1Entity)
    {
        return 4;
    }
}