package PuellaMagi.mods;

import net.minecraft.entity.EntityLiving;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.util.MathHelper;
import net.minecraft.world.World;

public class EntitySpear extends EntityMadomagiWeapon
{
    public EntitySpear(World par1World)
    {
        super(par1World);
    }

    public EntitySpear(World par1World, double par2, double par4, double par6)
    {
        super(par1World, par2, par4, par6);
    }

    public EntitySpear(World par1World, EntityLiving par2EntityLiving, EntityLiving par3EntityLiving, float par4, float par5)
    {
        super(par1World);
        this.shootingEntity = par2EntityLiving;

        if (par2EntityLiving instanceof EntityPlayer)
        {
        	this.canBePickedUp = 1;
        }
        double var6 = -(this.rand.nextDouble() - 0.5D) * par3EntityLiving.width * 3.0D;
        double var8 = (double)par3EntityLiving.getEyeHeight() -0.1D;
        double var10 = -(this.rand.nextDouble() - 0.5D) * par3EntityLiving.width * 3.0D;
        double var12 = (double)MathHelper.sqrt_double(var6 * var6 + var10 * var10);

        if (var12 >= 1.0E-7D)
        {
        	float var14 = (float)(Math.atan2(var10, var6) * 180.0D / Math.PI) - 90.0F;
        	float var15 = (float)(-(Math.atan2(var8, var12) * 180.0D / Math.PI));
        	double var16 = var6 / var12;
        	double var18 = var10 / var12;
        	double var22 = par3EntityLiving.posX - var6;
        	int var24 = (int)(par3EntityLiving.posY + par3EntityLiving.getEyeHeight());
        	double var26 = par3EntityLiving.posZ - var10;
        	int var28 = 0;
        	do
        	{
        		var24--;
        		var28++;
        	}
        	while (!this.worldObj.doesBlockHaveSolidTopSurface((int)var22, (int)var24 - 1, (int)var26) && var28 < 32);
        	this.setLocationAndAngles(var22, var24 + 0.5D, var26, var14, var15);
        	this.yOffset = 0.0F;
        	float var20 = (float)var12 * 0.2F;
        	this.setThrowableHeading(var6, var8 + (double)var20, var10, 2.0F, 1.0F);
        }
    }

    public EntitySpear(World par1World, EntityLiving par2EntityLiving, float par3)
    {
        super(par1World, par2EntityLiving, par3);
    }

    @Override
    protected Item getItemMadomagiWeapon()
    {
        return mod_QB.kyoukoSpear;
    }
}