package PuellaMagi.mods;

import net.minecraft.enchantment.Enchantment;
import net.minecraft.enchantment.EnchantmentHelper;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLiving;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemBow;
import net.minecraft.item.ItemStack;
import net.minecraft.world.World;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.event.entity.player.ArrowLooseEvent;
import net.minecraftforge.event.entity.player.ArrowNockEvent;

public class ItemMadokaBow extends ItemBow
{
    public ItemMadokaBow(int par1)
    {
        super(par1);
        this.setMaxDamage(1561);
    }

    @Override
    public boolean hitEntity(ItemStack par1ItemStack, EntityLiving par2EntityLiving, EntityLiving par3EntityLiving)
    {
        par1ItemStack.damageItem(1, par3EntityLiving);
        return true;
    }

    @Override
    public int getDamageVsEntity(Entity par1Entity)
    {
        return 4;
    }

    @Override
    public boolean isFull3D()
    {
        return true;
    }

    @Override
    public void onPlayerStoppedUsing(ItemStack par1ItemStack, World par2World, EntityPlayer par3EntityPlayer, int par4)
    {
        int var6 = this.getMaxItemUseDuration(par1ItemStack) - par4;

        ArrowLooseEvent event = new ArrowLooseEvent(par3EntityPlayer, par1ItemStack, var6);
        MinecraftForge.EVENT_BUS.post(event);
        if (event.isCanceled())
        {
        	return;
        }
        var6 = event.charge;

        boolean var5 = par3EntityPlayer.capabilities.isCreativeMode || EnchantmentHelper.getEnchantmentLevel(Enchantment.infinity.effectId, par1ItemStack) > 0;

        if (var5 || par3EntityPlayer.inventory.hasItem(mod_QB.itemLightArrow.shiftedIndex))
        {
        	float var7 = (float)var6 / 20.0F;
        	var7 = (var7 * var7 + var7 * 2.0F) / 3.0F;

        	if ((double)var7 < 0.1D)
        	{
        		return;
        	}

        	if (var7 > 1.0F)
        	{
        		var7 = 1.0F;
        	}

        	for (int var1 = 0; var1 < 5; var1++)
        	{
        		EntityLightArrow var8 = new EntityLightArrow(par2World, par3EntityPlayer, var7 * 2.0F);
        		var8.setThrowableHeading(var8.motionX, var8.motionY, var8.motionZ, var7 * 3.0F, 6.0F);

        		int var9 = EnchantmentHelper.getEnchantmentLevel(Enchantment.power.effectId, par1ItemStack);
        		if (var9 > 0)
        		{
        			var8.setDamagePower(var8.getDamagePower() + (double)var9 * 0.5D + 0.5D);
        		}

        		int var10 = EnchantmentHelper.getEnchantmentLevel(Enchantment.punch.effectId, par1ItemStack);
        		if (var10 > 0)
        		{
        			var8.setKnockbackStrength(var10);
        		}

        		if (EnchantmentHelper.getEnchantmentLevel(Enchantment.flame.effectId, par1ItemStack) > 0)
        		{
        			var8.setFire(100);
        		}

        		par2World.playSoundAtEntity(par3EntityPlayer, "random.bow", 1.0F, 1.0F / (itemRand.nextFloat() * 0.4F + 1.2F) + var7 * 0.5F);

        		if (!par2World.isRemote)
        		{
        			par2World.spawnEntityInWorld(var8);
        		}
        	}

        	par1ItemStack.damageItem(1, par3EntityPlayer);

        	if (!var5)
        	{
        		par3EntityPlayer.inventory.consumeInventoryItem(mod_QB.itemLightArrow.shiftedIndex);
        	}
        }
    }

    @Override
    public ItemStack onItemRightClick(ItemStack par1ItemStack, World par2World, EntityPlayer par3EntityPlayer)
    {
        ArrowNockEvent event = new ArrowNockEvent(par3EntityPlayer, par1ItemStack);
        MinecraftForge.EVENT_BUS.post(event);
        if (event.isCanceled())
        {
        	return event.result;
        }

        if (par3EntityPlayer.capabilities.isCreativeMode || par3EntityPlayer.inventory.hasItem(mod_QB.itemLightArrow.shiftedIndex))
        {
        	par3EntityPlayer.setItemInUse(par1ItemStack, this.getMaxItemUseDuration(par1ItemStack));
        }

        return par1ItemStack;
    }

    @Override
    public int getIconIndex(ItemStack par1ItemStack, int par2, EntityPlayer par3EntityPlayer, ItemStack par4ItemStack, int par5)
    {
        if (par4ItemStack != null && par4ItemStack.getItem().shiftedIndex == this.shiftedIndex)
        {
        	int var1 = par4ItemStack.getMaxItemUseDuration() - par5;
        	if (var1 >= 18) return 100;
        	if (var1 >  13) return 99;
        	if (var1 >   0) return 98;
        }
        return super.getIconIndex(par1ItemStack);
    }

    @Override
    public String getTextureFile()
    {
        return "/PuellaMagi/Items/madomagiItem.png";
    }
}