package PuellaMagi.mods;

import net.minecraft.block.Block;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.Facing;
import net.minecraft.world.World;

public class ItemSoulGem extends Item
{
    private int ItemID;

    public ItemSoulGem(int par1, int par2)
    {
        super(par1);
        this.ItemID = par2;
        this.maxStackSize = 1;
        this.setMaxDamage(63);
        this.setCreativeTab(CreativeTabs.tabMisc);
    }

    @Override
    public int getIconFromDamageForRenderPass(int par1, int par2)
    {
        return par2 == 0 ? super.getIconFromDamageForRenderPass(par1, par2) : 1;
    }

    @Override
    public int getColorFromItemStack(ItemStack par1ItemStack, int par2)
    {
        if (par2 > 0)
        {
        	return 16777215;
        }
        else
        {
        	if (par1ItemStack.getItemDamage() < 16)
        	{
        		return 16777215;
        	}
        	else if (par1ItemStack.getItemDamage() < 32)
        	{
        		return 11184810;
        	}
        	else if (par1ItemStack.getItemDamage() < 48)
        	{
        		return 5592405;
        	}
        	else
        	{
        		return 0;
        	}
        }
    }

    @Override
    public boolean requiresMultipleRenderPasses()
    {
        return true;
    }

    @Override
    public boolean hasEffect(ItemStack par1ItemStack)
    {
        return false;
    }

    @Override
    public boolean onItemUse(ItemStack par1ItemStack, EntityPlayer par2EntityPlayer, World par3World, int par4, int par5, int par6, int par7, float par8, float par9, float par10)
    {
        if (par3World.isRemote)
        {
        	return true;
        }
        else
        {
        	int var11 = par3World.getBlockId(par4, par5, par6);
        	par4 += Facing.offsetsXForSide[par7];
        	par5 += Facing.offsetsYForSide[par7];
        	par6 += Facing.offsetsZForSide[par7];
        	double var12 = 0.0D;

        	if (par7 == 1 && var11 == Block.fence.blockID || var11 == Block.netherFence.blockID)
        	{
        		var12 = 0.5D;
        	}

        	if (this.spawnMadomagi(par1ItemStack, par3World, (double)par4 + 0.5D, (double)par5 + var12, (double)par6 + 0.5D) != null && !par2EntityPlayer.capabilities.isCreativeMode)
        	{
        		--par1ItemStack.stackSize;
        	}

        	return true;
        }
    }

    public EntityMahoShojo spawnMadomagi(ItemStack par1ItemStack, World par2World, double par3, double par4, double par5)
    {
        EntityMahoShojo var1;

        switch (this.ItemID)
        {
        	case 0:
        		var1 = new EntityMadoka(par2World);
        		break;

        	case 1:
        		var1 = new EntityHomura(par2World);
        		break;

        	case 2:
        		var1 = new EntitySayaka(par2World);
        		break;

        	case 3:
        		var1 = new EntityMami(par2World);
        		break;

        	case 4:
        		var1 = new EntityKyouko(par2World);
        		break;

        	default:
        		var1 = null;
        		break;
        }

        if (var1 != null)
        {
        	var1.setLocationAndAngles(par3, par4, par5, par2World.rand.nextFloat() * 360.0F, 0.0F);
        	var1.setSoulGemDamage(par1ItemStack.getItemDamage());
        	par2World.spawnEntityInWorld(var1);
        }

        return var1;
    }

    @Override
    public String getTextureFile()
    {
        return "/PuellaMagi/Items/madomagiItem.png";
    }
}