package PuellaMagi.mods.client;

import net.minecraft.client.model.ModelBiped;
import net.minecraft.client.model.ModelCreeper;
import net.minecraftforge.client.MinecraftForgeClient;
import PuellaMagi.mods.CommonProxy;
import PuellaMagi.mods.EntityAdelbert;
import PuellaMagi.mods.EntityAnthony;
import PuellaMagi.mods.EntityCutlass;
import PuellaMagi.mods.EntityFireLance;
import PuellaMagi.mods.EntityGertrud;
import PuellaMagi.mods.EntityGriefSeed;
import PuellaMagi.mods.EntityHomura;
import PuellaMagi.mods.EntityKriemhildGretchen;
import PuellaMagi.mods.EntityKyouko;
import PuellaMagi.mods.EntityLightArrow;
import PuellaMagi.mods.EntityMadoka;
import PuellaMagi.mods.EntityMadomagiBullet;
import PuellaMagi.mods.EntityMami;
import PuellaMagi.mods.EntityMusket;
import PuellaMagi.mods.EntityPrickle;
import PuellaMagi.mods.EntityQB;
import PuellaMagi.mods.EntitySayaka;
import PuellaMagi.mods.EntityShadowPuellaMagi;
import PuellaMagi.mods.EntitySpear;
import PuellaMagi.mods.EntityWalpurgisnacht;
import cpw.mods.fml.client.registry.RenderingRegistry;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

@SideOnly(Side.CLIENT)
public class ClientProxy extends CommonProxy
{
    @Override
    public void registerTextures()
    {
        MinecraftForgeClient.preloadTexture("/PuellaMagi/Items/madomagiItem.png");
    }

    @Override
    public void registerRenderers()
    {
        //Madomagi
        RenderingRegistry.registerEntityRenderingHandler(EntityMadoka.class, new RenderMahoShojo(new ModelMadoka(), new ModelMadokaMS(), 0.5F));
        RenderingRegistry.registerEntityRenderingHandler(EntityHomura.class, new RenderMahoShojo(new ModelHomura(), new ModelHomuraMS(), 0.5F));
        RenderingRegistry.registerEntityRenderingHandler(EntitySayaka.class, new RenderMahoShojo(new ModelBiped(), new ModelSayakaMS(), 0.5F));
        RenderingRegistry.registerEntityRenderingHandler(EntityMami.class, new RenderMahoShojo(new ModelMami(), new ModelMamiMS(), 0.5F));
        RenderingRegistry.registerEntityRenderingHandler(EntityKyouko.class, new RenderMahoShojo(new ModelKyouko(), new ModelKyoukoMS(), 0.5F));
        RenderingRegistry.registerEntityRenderingHandler(EntityQB.class, new RenderQB(new ModelQB(), 0.5F));
        //Majo
        RenderingRegistry.registerEntityRenderingHandler(EntityKriemhildGretchen.class, new RenderKriemhildGretchen(new ModelCreeper(), 0.5F, 15.0F));
        RenderingRegistry.registerEntityRenderingHandler(EntityGertrud.class, new RenderMajo(new ModelGertrud(), 0.5F, 4.0F));
        RenderingRegistry.registerEntityRenderingHandler(EntityAdelbert.class, new RenderMajo(new ModelAdelbert(), 0.5F, 1.0F));
        RenderingRegistry.registerEntityRenderingHandler(EntityAnthony.class, new RenderMajo(new ModelAnthony(), 0.5F, 1.0F));
        RenderingRegistry.registerEntityRenderingHandler(EntityWalpurgisnacht.class, new RenderWalpurgisnacht(new ModelWalpurgisnacht(), 0.5F, 5.0F));
        RenderingRegistry.registerEntityRenderingHandler(EntityShadowPuellaMagi.class, new RenderShadowPuellaMagi(new ModelBiped(), 0.5F, 0.7F));
        //Others
        RenderingRegistry.registerEntityRenderingHandler(EntityGriefSeed.class, new RenderGriefSeed());
        RenderingRegistry.registerEntityRenderingHandler(EntityLightArrow.class, new RenderLightArrow());
        RenderingRegistry.registerEntityRenderingHandler(EntityMadomagiBullet.class, new RenderMadomagiBullet());
        RenderingRegistry.registerEntityRenderingHandler(EntityCutlass.class, new RenderCutlass());
        RenderingRegistry.registerEntityRenderingHandler(EntityMusket.class, new RenderMusket());
        RenderingRegistry.registerEntityRenderingHandler(EntitySpear.class, new RenderSpear());
        RenderingRegistry.registerEntityRenderingHandler(EntityFireLance.class, new RenderFireLance());
        RenderingRegistry.registerEntityRenderingHandler(EntityPrickle.class, new RenderPrickle());
    }
}