package PuellaMagi.mods.client;

import net.minecraft.client.model.ModelBase;
import net.minecraft.client.model.ModelRenderer;
import net.minecraft.entity.Entity;
import net.minecraft.util.MathHelper;

public class ModelAdelbert extends ModelBase
{
    ModelRenderer Head;
    ModelRenderer MedianHeadA;
    ModelRenderer MedianHeadP;
    ModelRenderer RightHeadA;
    ModelRenderer RightHeadM;
    ModelRenderer RightHeadP;
    ModelRenderer LeftHeadA;
    ModelRenderer LeftHeadM;
    ModelRenderer LeftHeadP;
    ModelRenderer Body;
    ModelRenderer Tail1;
    ModelRenderer Tail2;
    ModelRenderer Tail3;
    ModelRenderer Tail4;
    ModelRenderer RightWing;
    ModelRenderer LeftWing;

    public ModelAdelbert()
    {
        this.textureWidth = 64;
        this.textureHeight = 32;

        this.Head = new ModelRenderer(this, 0, 0);
        this.Head.addBox(-4F, -8F, -4F, 8, 8, 8);
        this.Head.setRotationPoint(0F, 4F, 0F);

        this.MedianHeadA = new ModelRenderer(this, 0, 0);
        this.MedianHeadA.addBox(-1.0F, 0.0F, -1.0F, 2, 2, 2);
        this.MedianHeadA.setRotationPoint(0.0F, 0.0F, -3.0F);
        this.MedianHeadP = new ModelRenderer(this, 0, 0);
        this.MedianHeadP.addBox(-1F, 0F, -1F, 2, 2, 2);
        this.MedianHeadP.setRotationPoint(0.0F, 0.0F, 3.0F);
        this.RightHeadA = new ModelRenderer(this, 0, 0);
        this.RightHeadA.addBox(-1F, 0F, -1F, 2, 2, 2);
        this.RightHeadA.setRotationPoint(-3.0F, 0.0F, -3.0F);
        this.RightHeadM = new ModelRenderer(this, 0, 0);
        this.RightHeadM.addBox(-1F, 0F, -1F, 2, 2, 2);
        this.RightHeadM.setRotationPoint(-3.0F, 0.0F, 0.0F);
        this.RightHeadP = new ModelRenderer(this, 0, 0);
        this.RightHeadP.addBox(-1F, 0F, -1F, 2, 2, 2);
        this.RightHeadP.setRotationPoint(-3.0F, 0.0F, 3.0F);
        this.LeftHeadA = new ModelRenderer(this, 0, 0);
        this.LeftHeadA.mirror = true;
        this.LeftHeadA.addBox(-1F, 0F, -1F, 2, 2, 2);
        this.LeftHeadA.setRotationPoint(3.0F, 0.0F, -3.0F);
        this.LeftHeadM = new ModelRenderer(this, 0, 0);
        this.LeftHeadM.mirror = true;
        this.LeftHeadM.addBox(-1F, 0F, -1F, 2, 2, 2);
        this.LeftHeadM.setRotationPoint(3.0F, 0.0F, 0.0F);
        this.LeftHeadP = new ModelRenderer(this, 0, 0);
        this.LeftHeadP.mirror = true;
        this.LeftHeadP.addBox(-1F, 0F, -1F, 2, 2, 2);
        this.LeftHeadP.setRotationPoint(3.0F, 0.0F, 3.0F);
        this.Head.addChild(this.MedianHeadA);
        this.Head.addChild(this.MedianHeadP);
        this.Head.addChild(this.RightHeadA);
        this.Head.addChild(this.RightHeadM);
        this.Head.addChild(this.RightHeadP);
        this.Head.addChild(this.LeftHeadA);
        this.Head.addChild(this.LeftHeadM);
        this.Head.addChild(this.LeftHeadP);

        this.Body = new ModelRenderer(this, 0, 16);
        this.Body.addBox(-3F, 0F, -3F, 6, 6, 6);
        this.Body.setRotationPoint(0F, 4F, 0F);
        this.Tail1 = new ModelRenderer(this, 24, 16);
        this.Tail1.addBox(-2F, 0F, -2F, 4, 2, 4);
        this.Tail1.setRotationPoint(0F, 6F, 0F);
        this.Tail2 = new ModelRenderer(this, 24, 22);
        this.Tail2.addBox(-1.5F, 0F, -1.5F, 3, 2, 3);
        this.Tail2.setRotationPoint(0F, 2F, 0F);
        this.Tail3 = new ModelRenderer(this, 24, 27);
        this.Tail3.addBox(-1F, 0F, -1F, 2, 2, 2);
        this.Tail3.setRotationPoint(0F, 2F, 0F);
        this.Tail4 = new ModelRenderer(this, 32, 27);
        this.Tail4.addBox(-0.5F, 0F, -0.5F, 1, 2, 1);
        this.Tail4.setRotationPoint(0F, 2F, 0F);
        this.Body.addChild(this.Tail1);
        this.Tail1.addChild(this.Tail2);
        this.Tail2.addChild(this.Tail3);
        this.Tail3.addChild(this.Tail4);

        this.RightWing = new ModelRenderer(this, 32, 0);
        this.RightWing.addBox(-8F, -4F, 0F, 8, 14, 0);
        this.RightWing.setRotationPoint(0.0F, -4.0F, 4.0F);
        this.LeftWing = new ModelRenderer(this, 32, 0);
        this.LeftWing.mirror = true;
        this.LeftWing.addBox(0F, -4F, 0F, 8, 14, 0);
        this.LeftWing.setRotationPoint(0.0F, -4.0F, 4.0F);
        this.Head.addChild(this.RightWing);
        this.Head.addChild(this.LeftWing);
    }

    @Override
    public void render(Entity par1Entity, float par2, float par3, float par4, float par5, float par6, float par7)
    {
        this.setRotationAngles(par2, par3, par4, par5, par6, par7, par1Entity);
        this.Head.render(par7);
        this.Body.render(par7);
    }

    @Override
    public void setRotationAngles(float par1, float par2, float par3, float par4, float par5, float par6, Entity par7Entity)
    {
        this.Head.rotateAngleX = par5 / (180F / (float)Math.PI);
        this.Head.rotateAngleY = par4 / (180F / (float)Math.PI);
        float var1 = 0.1F + MathHelper.sin(par3 * 0.05F) * 0.1F;
        this.MedianHeadA.rotateAngleX = this.RightHeadA.rotateAngleX = this.LeftHeadA.rotateAngleX = -var1;
        this.MedianHeadP.rotateAngleX = this.RightHeadP.rotateAngleX = this.LeftHeadP.rotateAngleX = var1;
        this.RightHeadA.rotateAngleZ = this.RightHeadM.rotateAngleZ = this.RightHeadP.rotateAngleZ = var1;
        this.LeftHeadA.rotateAngleZ = this.LeftHeadM.rotateAngleZ = this.LeftHeadP.rotateAngleZ = -var1;
        float var2 = var1 * 2.0F + 0.1F;
        this.RightWing.rotateAngleY = var2;
        this.LeftWing.rotateAngleY = -var2;
    }
}