package PuellaMagi.mods.client;

import net.minecraft.client.model.ModelBase;
import net.minecraft.client.model.ModelRenderer;
import net.minecraft.entity.Entity;
import net.minecraft.util.MathHelper;

public class ModelAnthony extends ModelBase
{
    ModelRenderer Head;
    ModelRenderer Body1;
    ModelRenderer Body2;
    ModelRenderer RightArm1;
    ModelRenderer RightArm2;
    ModelRenderer LeftArm1;
    ModelRenderer LeftArm2;
    ModelRenderer RightWing;
    ModelRenderer LeftWing;

    public ModelAnthony()
    {
        this.textureWidth = 64;
        this.textureHeight = 32;

        this.Head = new ModelRenderer(this, 0, 0);
        this.Head.addBox(-4.0F, -8.0F, -4.0F, 8, 8, 8);
        this.Head.setRotationPoint(0.0F, 4.0F, 0.0F);

        this.Body1 = new ModelRenderer(this, 0, 16);
        this.Body1.addBox(-1F, 0F, -1F, 2, 8, 2);
        this.Body1.setRotationPoint(0F, 4F, 0F);
        this.Body2 = new ModelRenderer(this, 8, 16);
        this.Body2.addBox(-0.5F, 0F, -0.5F, 1, 8, 1);
        this.Body2.setRotationPoint(0F, 8F, 0F);
        this.Body1.addChild(this.Body2);

        this.RightArm1 = new ModelRenderer(this, 12, 16);
        this.RightArm1.addBox(-1.0F, 0.0F, -0.5F, 1, 4, 1);
        this.RightArm1.setRotationPoint(-1F, 4F, 0.0F);
        this.RightArm2 = new ModelRenderer(this, 12, 16);
        this.RightArm2.addBox(-1.0F, 0.0F, -0.5F, 1, 4, 1);
        this.RightArm2.setRotationPoint(0.0F, 4.0F, 0.0F);
        this.RightArm1.addChild(this.RightArm2);

        this.LeftArm1 = new ModelRenderer(this, 12, 16);
        this.LeftArm1.mirror = true;
        this.LeftArm1.addBox(0F, 0F, -0.5F, 1, 4, 1);
        this.LeftArm1.setRotationPoint(1F, 4F, 0F);
        this.LeftArm2 = new ModelRenderer(this, 12, 16);
        this.LeftArm2.mirror = true;
        this.LeftArm2.addBox(0.0F, 0.0F, -0.5F, 1, 4, 1);
        this.LeftArm2.setRotationPoint(0.0F, 4.0F, 0.0F);
        this.LeftArm1.addChild(this.LeftArm2);

        this.RightWing = new ModelRenderer(this, 32, 0);
        this.RightWing.addBox(-10F, -6F, 0F, 10, 12, 0);
        this.RightWing.setRotationPoint(0F, 18F, 0F);
        this.LeftWing = new ModelRenderer(this, 32, 0);
        this.LeftWing.mirror = true;
        this.LeftWing.addBox(0F, -6F, 0F, 10, 12, 0);
        this.LeftWing.setRotationPoint(0F, 18F, 0F);
    }

    @Override
    public void render(Entity par1Entity, float par2, float par3, float par4, float par5, float par6, float par7)
    {
        this.setRotationAngles(par2, par3, par4, par5, par6, par7, par1Entity);
        this.Head.render(par7);
        this.Body1.render(par7);
        this.RightArm1.render(par7);
        this.LeftArm1.render(par7);
        this.RightWing.render(par7);
        this.LeftWing.render(par7);
    }

    @Override
    public void setRotationAngles(float par1, float par2, float par3, float par4, float par5, float par6, Entity par7Entity)
    {
        this.Head.rotateAngleX = par5 / (180F / (float)Math.PI);
        this.Head.rotateAngleY = par4 / (180F / (float)Math.PI);
        float var0 = MathHelper.cos(par1 * 0.6662F) * 1.0F * par2;
        this.RightArm1.rotateAngleX = var0;
        this.LeftArm1.rotateAngleX = -var0;
        float var1 = 0.1F + MathHelper.sin(par3 * 0.05F) * 0.1F;
        this.RightArm1.rotateAngleZ = this.RightArm2.rotateAngleZ = var1;
        this.LeftArm1.rotateAngleZ = this.LeftArm2.rotateAngleZ = -var1;
        float var2 = var1 * 2.0F;
        this.RightWing.rotateAngleY = var2;
        this.LeftWing.rotateAngleY = -var2;
    }
}