package PuellaMagi.mods.client;

import net.minecraft.client.model.ModelBase;
import net.minecraft.client.model.ModelRenderer;
import net.minecraft.entity.Entity;
import net.minecraft.util.MathHelper;

public class ModelGertrud extends ModelBase
{
    ModelRenderer Head1;
    ModelRenderer Head2;
    ModelRenderer MedianHeadA;
    ModelRenderer MedianHeadP;
    ModelRenderer RightHeadA;
    ModelRenderer RightHeadM;
    ModelRenderer RightHeadP;
    ModelRenderer LeftHeadA;
    ModelRenderer LeftHeadM;
    ModelRenderer LeftHeadP;
    ModelRenderer Neck;
    ModelRenderer Body1;
    ModelRenderer Body2;
    ModelRenderer Body3;
    ModelRenderer RightLegA1;
    ModelRenderer RightLegA2;
    ModelRenderer RightLegM1;
    ModelRenderer RightLegM2;
    ModelRenderer RightLegP1;
    ModelRenderer RightLegP2;
    ModelRenderer LeftLegA1;
    ModelRenderer LeftLegA2;
    ModelRenderer LeftLegM1;
    ModelRenderer LeftLegM2;
    ModelRenderer LeftLegP1;
    ModelRenderer LeftLegP2;
    ModelRenderer RightWing;
    ModelRenderer LeftWing;

    public ModelGertrud()
    {
        this.textureWidth = 64;
        this.textureHeight = 64;

        this.Body1 = new ModelRenderer(this, 0, 16);
        this.Body1.addBox(-2F, -6F, -2F, 4, 6, 4);
        this.Body1.setRotationPoint(0F, 7F, 9F);
        this.Body2 = new ModelRenderer(this, 0, 26);
        this.Body2.addBox(-3F, 0F, -3F, 6, 8, 6);
        this.Body2.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.Body3 = new ModelRenderer(this, 24, 26);
        this.Body3.addBox(-4F, 0F, -5F, 8, 3, 8);
        this.Body3.setRotationPoint(0.0F, 8.0F, 0.0F);
        this.Neck = new ModelRenderer(this, 16, 16);
        this.Neck.addBox(-1.5F, -3F, -5F, 3, 3, 7);
        this.Neck.setRotationPoint(0.0F, -6.0F, 0.0F);
        this.Body1.addChild(this.Body2);
        this.Body2.addChild(this.Body3);
        this.Body1.addChild(this.Neck);

        this.Head1 = new ModelRenderer(this, 0, 0);
        this.Head1.addBox(-4F, -4F, -8F, 8, 8, 8);
        this.Head1.setRotationPoint(0.0F, -1.0F, -5.0F);
        this.Head2 = new ModelRenderer(this, 0, 0);
        this.Head2.addBox(-4F, 0F, -4F, 8, 8, 8);
        this.Head2.setRotationPoint(0.0F, 4.0F, -4.0F);
        this.Neck.addChild(this.Head1);
        this.Head1.addChild(this.Head2);

        this.MedianHeadA = new ModelRenderer(this, 0, 0);
        this.MedianHeadA.addBox(-1F, 0F, -1F, 2, 3, 2);
        this.MedianHeadA.setRotationPoint(0.0F, 8.0F, -3.0F);
        this.MedianHeadP = new ModelRenderer(this, 0, 0);
        this.MedianHeadP.addBox(-1F, 0F, -1F, 2, 3, 2);
        this.MedianHeadP.setRotationPoint(0.0F, 8.0F, 3.0F);
        this.RightHeadA = new ModelRenderer(this, 0, 0);
        this.RightHeadA.addBox(-1F, 0F, -1F, 2, 5, 2);
        this.RightHeadA.setRotationPoint(-3F, 8.0F, -3F);
        this.RightHeadM = new ModelRenderer(this, 0, 0);
        this.RightHeadM.addBox(-1F, 0F, -1F, 2, 4, 2);
        this.RightHeadM.setRotationPoint(-3F, 8.0F, 0F);
        this.RightHeadP = new ModelRenderer(this, 0, 0);
        this.RightHeadP.addBox(-1F, 0F, -1F, 2, 3, 2);
        this.RightHeadP.setRotationPoint(-3F, 8.0F, 3F);
        this.LeftHeadA = new ModelRenderer(this, 0, 0);
        this.LeftHeadA.mirror = true;
        this.LeftHeadA.addBox(-1F, 0F, -1F, 2, 5, 2);
        this.LeftHeadA.setRotationPoint(3F, 8.0F, -3F);
        this.LeftHeadM = new ModelRenderer(this, 0, 0);
        this.LeftHeadM.mirror = true;
        this.LeftHeadM.addBox(-1F, 0F, -1F, 2, 4, 2);
        this.LeftHeadM.setRotationPoint(3F, 8.0F, 0F);
        this.LeftHeadP = new ModelRenderer(this, 0, 0);
        this.LeftHeadP.mirror = true;
        this.LeftHeadP.addBox(-1F, 0F, -1F, 2, 3, 2);
        this.LeftHeadP.setRotationPoint(3F, 8.0F, 3F);
        this.Head2.addChild(this.MedianHeadA);
        this.Head2.addChild(this.MedianHeadP);
        this.Head2.addChild(this.RightHeadA);
        this.Head2.addChild(this.RightHeadM);
        this.Head2.addChild(this.RightHeadP);
        this.Head2.addChild(this.LeftHeadA);
        this.Head2.addChild(this.LeftHeadM);
        this.Head2.addChild(this.LeftHeadP);

        this.RightLegA1 = new ModelRenderer(this, 24, 1);
        this.RightLegA1.addBox(-1F, 0F, -1F, 2, 4, 2);
        this.RightLegA1.setRotationPoint(-3.0F, 3.0F, -4.0F);
        this.RightLegA2 = new ModelRenderer(this, 24, 0);
        this.RightLegA2.addBox(-1F, 0F, -1F, 2, 4, 2);
        this.RightLegA2.setRotationPoint(0.0F, 4.0F, 0.0F);
        this.RightLegM1 = new ModelRenderer(this, 24, 0);
        this.RightLegM1.addBox(-1F, 0F, -1F, 2, 4, 2);
        this.RightLegM1.setRotationPoint(-3.0F, 3.0F, -1.0F);
        this.RightLegM2 = new ModelRenderer(this, 24, 0);
        this.RightLegM2.addBox(-1F, 0F, -1F, 2, 4, 2);
        this.RightLegM2.setRotationPoint(0.0F, 4.0F, 0.0F);
        this.RightLegP1 = new ModelRenderer(this, 24, 1);
        this.RightLegP1.addBox(-1F, 0F, -1F, 2, 4, 2);
        this.RightLegP1.setRotationPoint(-3.0F, 3.0F, 2.0F);
        this.RightLegP2 = new ModelRenderer(this, 24, 0);
        this.RightLegP2.addBox(-1F, 0F, -1F, 2, 4, 2);
        this.RightLegP2.setRotationPoint(0.0F, 4.0F, 0.0F);
        this.LeftLegA1 = new ModelRenderer(this, 24, 0);
        this.LeftLegA1.mirror = true;
        this.LeftLegA1.addBox(-1F, 0F, -1F, 2, 4, 2);
        this.LeftLegA1.setRotationPoint(3.0F, 3.0F, -4.0F);
        this.LeftLegA2 = new ModelRenderer(this, 24, 0);
        this.LeftLegA2.mirror = true;
        this.LeftLegA2.addBox(-1F, 0F, -1F, 2, 4, 2);
        this.LeftLegA2.setRotationPoint(0.0F, 4.0F, 0.0F);
        this.LeftLegM1 = new ModelRenderer(this, 24, 0);
        this.LeftLegM1.mirror = true;
        this.LeftLegM1.addBox(-1F, 0F, -1F, 2, 4, 2);
        this.LeftLegM1.setRotationPoint(3.0F, 3.0F, -1.0F);
        this.LeftLegM2 = new ModelRenderer(this, 24, 1);
        this.LeftLegM2.mirror = true;
        this.LeftLegM2.addBox(-1F, 0F, -1F, 2, 4, 2);
        this.LeftLegM2.setRotationPoint(0.0F, 4.0F, 0.0F);
        this.LeftLegP1 = new ModelRenderer(this, 24, 1);
        this.LeftLegP1.mirror = true;
        this.LeftLegP1.addBox(-1F, 0F, -1F, 2, 4, 2);
        this.LeftLegP1.setRotationPoint(3.0F, 3.0F, 2.0F);
        this.LeftLegP2 = new ModelRenderer(this, 24, 0);
        this.LeftLegP2.mirror = true;
        this.LeftLegP2.addBox(-1F, 0F, -1F, 2, 4, 2);
        this.LeftLegP2.setRotationPoint(0.0F, 4.0F, 0.0F);
        this.Body3.addChild(this.RightLegA1);
        this.RightLegA1.addChild(this.RightLegA2);
        this.Body3.addChild(this.RightLegM1);
        this.RightLegM1.addChild(this.RightLegM2);
        this.Body3.addChild(this.RightLegP1);
        this.RightLegP1.addChild(this.RightLegP2);
        this.Body3.addChild(this.LeftLegA1);
        this.LeftLegA1.addChild(this.LeftLegA2);
        this.Body3.addChild(this.LeftLegM1);
        this.LeftLegM1.addChild(this.LeftLegM2);
        this.Body3.addChild(this.LeftLegP1);
        this.LeftLegP1.addChild(this.LeftLegP2);

        this.RightWing = new ModelRenderer(this, 40, 0);
        this.RightWing.addBox(-12F, -11F, 0F, 12, 22, 0);
        this.RightWing.setRotationPoint(0.0F, 0.0F, 3.0F);
        this.LeftWing = new ModelRenderer(this, 40, 0);
        this.LeftWing.mirror = true;
        this.LeftWing.addBox(0F, -11F, 0F, 12, 22, 0);
        this.LeftWing.setRotationPoint(0.0F, 0.0F, 3.0F);
        this.Body2.addChild(this.RightWing);
        this.Body2.addChild(this.LeftWing);
    }

    @Override
    public void render(Entity par1Entity, float par2, float par3, float par4, float par5, float par6, float par7)
    {
        this.setRotationAngles(par2, par3, par4, par5, par6, par7, par1Entity);
        this.Body1.render(par7);
    }

    @Override
    public void setRotationAngles(float par1, float par2, float par3, float par4, float par5, float par6, Entity par7Entity)
    {
        this.Neck.rotateAngleX = par5 / (180F / (float)Math.PI);
        this.Neck.rotateAngleY = par4 / (180F / (float)Math.PI);
        float var1 = MathHelper.cos(par1 * 0.6662F) * 1.0F * par2;
        float var2 = MathHelper.sin(par3 * 0.05F) * 0.1F;
        float var3 = MathHelper.sin(par3 * 0.05F) * 0.2F;
        float var4 = MathHelper.sin(par3 * 0.1F) * 0.1F;
        this.RightLegA1.rotateAngleX = -var1 - 1.1F + var2;
        this.RightLegM1.rotateAngleX = var1 - 0.7F + var4;
        this.RightLegP1.rotateAngleX = -var1 - 0.6F - var3;
        this.RightLegA2.rotateAngleX = -this.RightLegA1.rotateAngleX;
        this.RightLegM2.rotateAngleX = -this.RightLegM1.rotateAngleX;
        this.RightLegP2.rotateAngleX = -this.RightLegP1.rotateAngleX;
        this.LeftLegA1.rotateAngleX = var1 - 1.3F + var3;
        this.LeftLegM1.rotateAngleX = -var1 - 0.8F - var2;
        this.LeftLegP1.rotateAngleX = var1 - 0.3F + var2;
        this.LeftLegA2.rotateAngleX = -this.LeftLegA1.rotateAngleX;
        this.LeftLegM2.rotateAngleX = -this.LeftLegM1.rotateAngleX;
        this.LeftLegP2.rotateAngleX = -this.LeftLegP1.rotateAngleX;
        float var5 = 0.2F + MathHelper.sin(par3 * 0.05F) * 0.2F;
        this.RightWing.rotateAngleY = var5;
        this.LeftWing.rotateAngleY = -var5;
    }
}