package PuellaMagi.mods.client;

import net.minecraft.client.model.ModelBiped;
import net.minecraft.client.model.ModelRenderer;
import net.minecraft.entity.Entity;
import net.minecraft.util.MathHelper;

public class ModelHomura extends ModelBiped
{
    public ModelRenderer RightLong1;
    public ModelRenderer RightLong2;
    public ModelRenderer RightLong3;
    public ModelRenderer RightLong4;
    public ModelRenderer LeftLong1;
    public ModelRenderer LeftLong2;
    public ModelRenderer LeftLong3;
    public ModelRenderer LeftLong4;

    public ModelHomura()
    {
        this(0.0F);
    }

    public ModelHomura(float par1)
    {
        this(par1, 0.0F, 64, 32);
    }

    public ModelHomura(float par1, float par2, int par3, int par4)
    {
        super(par1, par2, par3, par4);

        this.RightLong1 = new ModelRenderer(this, 56, 18);
        this.RightLong1.addBox(-2.0F, 0.0F, 0.0F, 2, 6, 2, par1);
        this.RightLong1.setRotationPoint(-2.0F, 0.0F + par2, 2.0F);
        this.RightLong2 = new ModelRenderer(this, 56, 18);
        this.RightLong2.addBox(-2.0F, 0.0F, 0.0F, 2, 6, 2, par1);
        this.RightLong2.setRotationPoint(0.0F, 0.0F + par2, 2.0F);
        this.RightLong3 = new ModelRenderer(this, 56, 18);
        this.RightLong3.addBox(-2.0F, 0.0F, 0.0F, 2, 6, 2, par1);
        this.RightLong3.setRotationPoint(0.0F, 6.0F + par2, 0.0F);
        this.RightLong4 = new ModelRenderer(this, 56, 18);
        this.RightLong4.addBox(-2.0F, 0.0F, 0.0F, 2, 6, 2, par1);
        this.RightLong4.setRotationPoint(0.0F, 6.0F + par2, 0.0F);
        this.bipedHead.addChild(this.RightLong1);
        this.bipedHead.addChild(this.RightLong2);
        this.RightLong1.addChild(this.RightLong3);
        this.RightLong2.addChild(this.RightLong4);

        this.LeftLong1 = new ModelRenderer(this, 56, 18);
        this.LeftLong1.mirror = true;
        this.LeftLong1.addBox(0.0F, 0.0F, 0.0F, 2, 6, 2, par1);
        this.LeftLong1.setRotationPoint(2.0F, 0.0F + par2, 2.0F);
        this.LeftLong2 = new ModelRenderer(this, 56, 18);
        this.LeftLong2.mirror = true;
        this.LeftLong2.addBox(0.0F, 0.0F, 0.0F, 2, 6, 2, par1);
        this.LeftLong2.setRotationPoint(0.0F, 0.0F + par2, 2.0F);
        this.LeftLong3 = new ModelRenderer(this, 56, 18);
        this.LeftLong3.mirror = true;
        this.LeftLong3.addBox(0.0F, 0.0F, 0.0F, 2, 6, 2, par1);
        this.LeftLong3.setRotationPoint(0.0F, 6.0F + par2, 0.0F);
        this.LeftLong4 = new ModelRenderer(this, 56, 18);
        this.LeftLong4.mirror = true;
        this.LeftLong4.addBox(0.0F, 0.0F, 0.0F, 2, 6, 2, par1);
        this.LeftLong4.setRotationPoint(0.0F, 6.0F + par2, 0.0F);
        this.bipedHead.addChild(this.LeftLong1);
        this.bipedHead.addChild(this.LeftLong2);
        this.LeftLong1.addChild(this.LeftLong3);
        this.LeftLong2.addChild(this.LeftLong4);
    }

    @Override
    public void setRotationAngles(float par1, float par2, float par3, float par4, float par5, float par6, Entity par7Entity)
    {
        super.setRotationAngles(par1, par2, par3, par4, par5, par6, par7Entity);

        this.LeftLong1.rotateAngleX = this.LeftLong2.rotateAngleX = this.RightLong1.rotateAngleX = this.RightLong2.rotateAngleX = this.bipedHead.rotateAngleX > 0 ? -this.bipedHead.rotateAngleX / 2F : -this.bipedHead.rotateAngleX;

        float var1 = MathHelper.sin(par3 * 0.08F) * 0.1F;
        this.RightLong1.rotateAngleZ = -var1 + 0.1F;
        this.RightLong2.rotateAngleZ = (-var1 + 0.1F) * 0.5F;
        this.RightLong3.rotateAngleZ = -var1 + 0.34907F;
        this.RightLong4.rotateAngleZ = (-var1 + 0.34907F) * 0.5F;
        this.LeftLong1.rotateAngleZ = var1 -0.1F;
        this.LeftLong2.rotateAngleZ = (var1 -0.1F) * 0.5F;
        this.LeftLong3.rotateAngleZ = var1 - 0.34907F;
        this.LeftLong4.rotateAngleZ = (var1 - 0.34907F) * 0.5F;
    }
}