package PuellaMagi.mods.client;

import net.minecraft.client.model.ModelBiped;
import net.minecraft.client.model.ModelRenderer;
import net.minecraft.entity.Entity;
import net.minecraft.util.MathHelper;

public class ModelKyouko extends ModelBiped
{
    public ModelRenderer ponyTail1;
    public ModelRenderer ponyTail2;

    public ModelRenderer RightLong1;
    public ModelRenderer RightLong2;
    public ModelRenderer LeftLong1;
    public ModelRenderer LeftLong2;

    public ModelKyouko()
    {
        this(0.0F);
    }

    public ModelKyouko(float par1)
    {
        this(par1, 0.0F, 64, 64);
    }

    public ModelKyouko(float par1, float par2, int par3, int par4)
    {
        super(par1, par2, par3, par4);

        this.ponyTail1 = new ModelRenderer(this, 0, 32);
        this.ponyTail1.addBox(-3.0F, 0.0F, 0.0F, 6, 4, 2, par1);
        this.ponyTail1.setRotationPoint(0.0F, -8.0F + par2, 5.0F);
        this.ponyTail2 = new ModelRenderer(this, 16, 32);
        this.ponyTail2.addBox(-4.0F, 0.0F, 0.0F, 8, 6, 2, par1);
        this.ponyTail2.setRotationPoint(0.0F, 4.0F + par2, 0.0F);
        this.bipedHead.addChild(this.ponyTail1);
        this.ponyTail1.addChild(this.ponyTail2);

        this.RightLong1 = new ModelRenderer(this, 56, 16);
        this.RightLong1.addBox(-2.0F, 0.0F, -2.0F, 2, 6, 2, par1);
        this.RightLong1.setRotationPoint(-2.0F, 5.0F + par2, 2.0F);
        this.RightLong2 = new ModelRenderer(this, 56, 16);
        this.RightLong2.addBox(-2.0F, 0.0F, 0.0F, 2, 6, 2, par1);
        this.RightLong2.setRotationPoint(0.0F, 6.0F + par2, 0.0F);
        this.ponyTail2.addChild(this.RightLong1);
        this.ponyTail2.addChild(this.RightLong2);

        this.LeftLong1 = new ModelRenderer(this, 56, 16);
        this.LeftLong1.mirror = true;
        this.LeftLong1.addBox(0.0F, 0.0F, -2.0F, 2, 6, 2, par1);
        this.LeftLong1.setRotationPoint(2.0F, 5.0F + par2, 2.0F);
        this.LeftLong2 = new ModelRenderer(this, 56, 16);
        this.LeftLong2.mirror = true;
        this.LeftLong2.addBox(0.0F, 0.0F, 0.0F, 2, 6, 2, par1);
        this.LeftLong2.setRotationPoint(0.0F, 6.0F + par2, 0.0F);
        this.ponyTail2.addChild(this.LeftLong1);
        this.ponyTail2.addChild(this.LeftLong2);
    }

    @Override
    public void setRotationAngles(float par1, float par2, float par3, float par4, float par5, float par6, Entity par7Entity)
    {
        super.setRotationAngles(par1, par2, par3, par4, par5, par6, par7Entity);

        float var1 = Math.abs(MathHelper.cos(par1 * 0.6662F) * 0.5F * par2);
        this.ponyTail1.rotateAngleX = this.bipedHead.rotateAngleX > 0 ? -this.bipedHead.rotateAngleX / 2F : -this.bipedHead.rotateAngleX;
        this.ponyTail1.rotateAngleX += var1;
        this.ponyTail1.rotateAngleY = MathHelper.sin(par3 * 0.05F) * 0.1F;
        this.ponyTail2.rotateAngleX = 0.0F;
        this.ponyTail2.rotateAngleX += var1;

        float var2 = MathHelper.sin(par3 * 0.08F) * 0.1F - 0.2F;
        this.RightLong1.rotateAngleX = this.LeftLong1.rotateAngleX = -0.1F - var1 * 2.0F;
        this.RightLong2.rotateAngleX = 0.1F + var1;
        this.RightLong2.rotateAngleX = 0.1F + var1 * 2.0F;
        this.RightLong1.rotateAngleZ = -var1 - var2;
        this.RightLong2.rotateAngleZ = -var1 - var2 * 0.5F;
        this.LeftLong1.rotateAngleZ = var1 + var2;
        this.LeftLong2.rotateAngleZ = var1+ var2 * 0.5F;
    }
}