package PuellaMagi.mods.client;

import net.minecraft.client.model.ModelBiped;
import net.minecraft.client.model.ModelRenderer;
import net.minecraft.entity.Entity;
import net.minecraft.util.MathHelper;

public class ModelMadokaMS extends ModelBiped
{
    public ModelRenderer RightTail;
    public ModelRenderer LeftTail;

    public ModelRenderer skirt1;
    public ModelRenderer skirt2;

    public ModelMadokaMS()
    {
        this(0.0F);
    }

    public ModelMadokaMS(float par1)
    {
        this(par1, 0.0F, 64, 64);
    }

    public ModelMadokaMS(float par1, float par2, int par3, int par4)
    {
        super(par1, par2, par3, par4);

        this.RightTail = new ModelRenderer(this, 56, 20);
        this.RightTail.addBox(-9.0F, -6.0F, 0.0F, 3, 11, 1, par1);
        this.RightTail.setRotationPoint(0.0F, 0.0F + par2, 0.0F);
        this.LeftTail = new ModelRenderer(this, 56, 20);
        this.LeftTail.mirror = true;
        this.LeftTail.addBox(6.0F, -6.0F, 0.0F, 3, 11, 1, par1);
        this.LeftTail.setRotationPoint(0.0F, 0.0F + par2, 0.0F);
        this.bipedHead.addChild(this.RightTail);
        this.bipedHead.addChild(this.LeftTail);

        this.skirt1 = new ModelRenderer(this, 0, 32);
        this.skirt1.addBox(0.0F, 0.0F, 0.0F, 9, 2, 9, par1);
        this.skirt1.setRotationPoint(-4.5F, 9.0F + par2, -4.5F);
        this.skirt2 = new ModelRenderer(this, 0, 48);
        this.skirt2.addBox(0.0F, 0.0F, 0.0F, 12, 3, 12, par1);
        this.skirt2.setRotationPoint(-2.0F, 2.0F + par2, -2.0F);
        this.bipedBody.addChild(this.skirt1);
        this.skirt1.addChild(this.skirt2);
    }

    @Override
    public void setRotationAngles(float par1, float par2, float par3, float par4, float par5, float par6, Entity par7Entity)
    {
        super.setRotationAngles(par1, par2, par3, par4, par5, par6, par7Entity);

        float var1 = MathHelper.sin(par3 * 0.05F) * 0.1F - 0.34907F;
        this.RightTail.rotateAngleY = this.RightTail.rotateAngleZ = -var1;
        this.LeftTail.rotateAngleY = this.LeftTail.rotateAngleZ = var1;
    }
}