package PuellaMagi.mods.client;

import net.minecraft.client.model.ModelBiped;
import net.minecraft.client.model.ModelRenderer;
import net.minecraft.entity.Entity;
import net.minecraft.util.MathHelper;

public class ModelMami extends ModelBiped
{
    public ModelRenderer RightTail;
    public ModelRenderer LeftTail;

    public ModelMami()
    {
        this(0.0F);
    }

    public ModelMami(float par1)
    {
        this(par1, 0.0F, 64, 32);
    }

    public ModelMami(float par1, float par2, int par3, int par4)
    {
        super(par1, par2, par3, par4);

        this.RightTail = new ModelRenderer(this, 56, 16);
        this.RightTail.addBox(-2.0F, 0.0F, 0.0F, 2, 6, 2, par1);
        this.RightTail.setRotationPoint(-4.0F, 0.0F + par2, 4.0F);
        this.LeftTail = new ModelRenderer(this, 56, 16);
        this.LeftTail.mirror = true;
        this.LeftTail.addBox(0.0F, 0.0F, 0.0F, 2, 6, 2, par1);
        this.LeftTail.setRotationPoint(4.0F, 0.0F + par2, 4.0F);
        this.bipedHead.addChild(this.RightTail);
        this.bipedHead.addChild(this.LeftTail);
    }

    @Override
    public void setRotationAngles(float par1, float par2, float par3, float par4, float par5, float par6, Entity par7Entity)
    {
        super.setRotationAngles(par1, par2, par3, par4, par5, par6, par7Entity);

        float var1 = MathHelper.sin(par3 * 0.05F) * 0.1F - 0.34907F;
        this.RightTail.rotateAngleZ = -var1;
        this.LeftTail.rotateAngleZ = var1;
        this.RightTail.rotateAngleX = this.LeftTail.rotateAngleX = -var1;
    }
}