package PuellaMagi.mods.client;

import net.minecraft.client.model.ModelBiped;
import net.minecraft.client.model.ModelRenderer;
import net.minecraft.entity.Entity;
import net.minecraft.util.MathHelper;

public class ModelMamiMS extends ModelBiped
{
    public ModelRenderer hat;
    public ModelRenderer hatAccessory;

    public ModelRenderer RightTail;
    public ModelRenderer LeftTail;

    public ModelRenderer skirtbase;
    public ModelRenderer skirtF1;
    public ModelRenderer skirtF2;
    public ModelRenderer skirtL1;
    public ModelRenderer skirtL2;
    public ModelRenderer skirtR1;
    public ModelRenderer skirtR2;
    public ModelRenderer skirtB1;
    public ModelRenderer skirtB2;

    public ModelMamiMS()
    {
        this(0.0F);
    }

    public ModelMamiMS(float par1)
    {
        this(par1, 0.0F, 64, 64);
    }

    public ModelMamiMS(float par1, float par2, int par3, int par4)
    {
        super(par1, par2, par3, par4);

        this.hat = new ModelRenderer(this, 0, 32);
        this.hat.addBox(-2.5F, 0.0F, -2.5F, 5, 3, 5, par1);
        this.hat.setRotationPoint(0.0F, -11.0F + par2, 0.0F);
        this.hatAccessory = new ModelRenderer(this, 20, 32);
        this.hatAccessory.addBox(-2.0F, 0.0F, 0.0F, 2, 6, 3, par1);
        this.hatAccessory.setRotationPoint(-2.5F, 0.0F + par2, 0.0F);
        this.bipedHeadwear.addChild(this.hat);
        this.hat.addChild(this.hatAccessory);

        this.RightTail = new ModelRenderer(this, 56, 16);
        this.RightTail.addBox(-2.0F, 0.0F, 0.0F, 2, 6, 2, par1);
        this.RightTail.setRotationPoint(-4.0F, 0.0F + par2, 4.0F);
        this.LeftTail = new ModelRenderer(this, 56, 16);
        this.LeftTail.mirror = true;
        this.LeftTail.addBox(0.0F, 0.0F, 0.0F, 2, 6, 2, par1);
        this.LeftTail.setRotationPoint(4.0F, 0.0F + par2, 4.0F);
        this.bipedHead.addChild(this.RightTail);
        this.bipedHead.addChild(this.LeftTail);

        this.skirtbase = new ModelRenderer(this);
        this.skirtbase.setRotationPoint(0.0F, 6.5F, 0.0F);
        this.skirtF1 = new ModelRenderer(this, 0, 48);
        this.skirtF1.addBox(-7.2F, 2.0F, -1.5F, 8, 6, 0, par1);
        this.skirtF1.setRotationPoint(0.0F, 0.0F + par2, 0.0F);
        this.skirtF2 = new ModelRenderer(this, 0, 48);
        this.skirtF2.mirror = true;
        this.skirtF2.addBox(-0.8F, 2.0F, -1.5F, 8, 6, 0, par1);
        this.skirtF2.setRotationPoint(0.0F, 0.0F + par2, 0.0F);
        this.skirtR1 = new ModelRenderer(this, 3, 48);
        this.skirtR1.addBox(-6.0F, 2.0F, -1.0F, 6, 6, 0, par1);
        this.skirtR1.setRotationPoint(0.0F, 0.0F + par2, 0.0F);
        this.skirtR2 = new ModelRenderer(this, 3, 48);
        this.skirtR2.mirror = true;
        this.skirtR2.addBox(0.0F, 2.0F, -1.0F, 6, 6, 0, par1);
        this.skirtR2.setRotationPoint(0.0F, 0.0F + par2, 0.0F);
        this.skirtL1 = new ModelRenderer(this, 3, 48);
        this.skirtL1.mirror = true;
        this.skirtL1.addBox(0.0F, 2.0F, 1.0F, 6, 6, 0, par1);
        this.skirtL1.setRotationPoint(0.0F, 0.0F + par2, 0.0F);
        this.skirtL2 = new ModelRenderer(this, 3, 48);
        this.skirtL2.addBox(-6.0F, 2.0F, 1.0F, 6, 6, 0, par1);
        this.skirtL2.setRotationPoint(0.0F, 0.0F + par2, 0.0F);
        this.skirtB1 = new ModelRenderer(this, 0, 48);
        this.skirtB1.mirror = true;
        this.skirtB1.addBox(-0.8F, 2.0F, 1.5F, 8, 6, 0, par1);
        this.skirtB1.setRotationPoint(0.0F, 0.0F + par2, 0.0F);
        this.skirtB2 = new ModelRenderer(this, 0, 48);
        this.skirtB2.addBox(-7.3F, 2.0F, 1.5F, 8, 6, 0, par1);
        this.skirtB2.setRotationPoint(0.0F, 0.0F + par2, 0.0F);
        this.bipedBody.addChild(this.skirtbase);
        this.skirtbase.addChild(this.skirtF1);
        this.skirtbase.addChild(this.skirtF2);
        this.skirtbase.addChild(this.skirtR1);
        this.skirtbase.addChild(this.skirtR2);
        this.skirtbase.addChild(this.skirtL1);
        this.skirtbase.addChild(this.skirtL2);
        this.skirtbase.addChild(this.skirtB1);
        this.skirtbase.addChild(this.skirtB2);
    }

    @Override
    public void setRotationAngles(float par1, float par2, float par3, float par4, float par5, float par6, Entity par7Entity)
    {
        super.setRotationAngles(par1, par2, par3, par4, par5, par6, par7Entity);

        float var1 = MathHelper.cos(par1 * 0.3331F) * par2;
        this.hatAccessory.rotateAngleX = var1 * var1;
        this.hatAccessory.rotateAngleZ = 0.7854F - var1 * var1;

        float var2 = MathHelper.sin(par3 * 0.05F) * 0.1F - 0.34907F;
        this.RightTail.rotateAngleZ = -var2;
        this.LeftTail.rotateAngleZ = var2;
        this.RightTail.rotateAngleX = this.LeftTail.rotateAngleX = -var2;

        this.skirtB2.rotateAngleY = this.skirtB2.rotateAngleZ = this.skirtF1.rotateAngleZ = this.skirtF2.rotateAngleY = -0.2618F;
        this.skirtF1.rotateAngleY = this.skirtF2.rotateAngleZ = this.skirtB1.rotateAngleY = this.skirtB1.rotateAngleZ = 0.2618F;
        this.skirtR1.rotateAngleX = this.skirtR2.rotateAngleX = -0.61087F;
        this.skirtL1.rotateAngleX = this.skirtL2.rotateAngleX = 0.61087F;
        this.skirtR1.rotateAngleY = this.skirtR2.rotateAngleY = this.skirtL1.rotateAngleY = this.skirtL2.rotateAngleY = 1.5708F;
        this.skirtF1.rotateAngleX = this.skirtF2.rotateAngleX = -0.7854F;
        this.skirtB1.rotateAngleX = this.skirtB2.rotateAngleX = 0.7854F;
    }
}