package PuellaMagi.mods;

import java.util.logging.Level;

import net.minecraft.block.Block;
import net.minecraft.entity.EnumCreatureType;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.potion.Potion;
import net.minecraft.src.ModLoader;
import net.minecraft.world.WorldType;
import net.minecraft.world.biome.BiomeGenBase;
import net.minecraftforge.common.Configuration;
import cpw.mods.fml.common.FMLLog;
import cpw.mods.fml.common.Mod;
import cpw.mods.fml.common.SidedProxy;
import cpw.mods.fml.common.event.FMLInitializationEvent;
import cpw.mods.fml.common.event.FMLPreInitializationEvent;
import cpw.mods.fml.common.network.NetworkMod;
import cpw.mods.fml.common.registry.EntityRegistry;
import cpw.mods.fml.common.registry.GameRegistry;
import cpw.mods.fml.common.registry.LanguageRegistry;

@Mod(modid = "QB-MOD", name = "mod_QB", version = "1.4.6-c")

@NetworkMod(clientSideRequired = true, serverSideRequired = false)

public class mod_QB
{
    @SidedProxy(clientSide = "PuellaMagi.mods.client.ClientProxy", serverSide = "PuellaMagi.mods.CommonProxy")
    public static CommonProxy proxy;

    @Mod.Instance("mod_QB")
    public static mod_QB instance;

    private static int MadokaID;
    private static int HomuraID;
    private static int SayakaID;
    private static int MamiID ;
    private static int KyoukoID;
    private static int QBID;
    private static int GriefSeedID;
    public static int GSLightLevel;
    private static int KriemhildGretchenID;
    private static int GertrudID;
    private static int AdelbertID;
    private static int AnthonyID;
    public static boolean canWalpurgisSpawn;
    private static int WalpurgisnachtID;
    private static int ShadowPuellaMagiID;
    private static int LightArrowID;
    private static int BulletID;
    private static int CutlassID;
    private static int MusketID;
    private static int SpearID;
    private static int FireLanceID;
    private static int PrickleID;

    public static Item madokaRibbon;
    private static int madokaRibbonID;

    public static Item itemGriefSeed;
    private static int itemGriefSeedID;

    public static Item itemLightArrow;
    private static int itemLightArrowID;

    public static Item itemBullet;
    private static int itemBulletID;

    public static Item madokaGem;
    private static int madokaGemID;

    public static Item madokaBow;
    private static int madokaBowID;

    public static Item madokaWeapon;
    private static int madokaWeaponID;

    public static Item homuraGem;
    private static int homuraGemID;

    public static Item homuraGun1;
    private static int homuraGun1ID;

    public static Item homuraGun2;
    private static int homuraGun2ID;

    public static Item sayakaGem;
    private static int sayakaGemID;

    public static Item sayakaCutlass;
    private static int sayakaCutlassID;

    public static Item mamiGem;
    private static int mamiGemID;

    public static Item mamiMusket;
    private static int mamiMusketID;

    public static Item mamiTea;
    private static int mamiTeaID;

    public static Item kyoukoGem;
    private static int kyoukoGemID;

    public static Item kyoukoSpear;
    private static int kyoukoSpearID;

    @Mod.PreInit
    public void preInit(FMLPreInitializationEvent event)
    {
        Configuration cfg = new Configuration(event.getSuggestedConfigurationFile());
        try
        {
        	cfg.load();
        	//Item
        	this.madokaRibbonID = cfg.getItem("madokaRibbonID", 15000).getInt();
        	this.itemGriefSeedID = cfg.getItem("itemGriefSeedID", 15001).getInt();
        	this.itemLightArrowID = cfg.getItem("itemLightArrowID", 15002).getInt();
        	this.itemBulletID = cfg.getItem("itemBulletID", 15003).getInt();
        	this.madokaGemID = cfg.getItem("madokaGem", 15010).getInt();
        	this.madokaBowID = cfg.getItem("madokaBowID", 15011).getInt();
        	this.madokaWeaponID = cfg.getItem("madokaWeaponID", 15012).getInt();
        	this.homuraGemID = cfg.getItem("homuraGemID", 15020).getInt();
        	this.homuraGun1ID = cfg.getItem("homuraGun1ID", 15021).getInt();
        	this.homuraGun2ID = cfg.getItem("homuraGun2ID", 15022).getInt();
        	this.sayakaGemID = cfg.getItem("sayakaGemID", 15030).getInt();
        	this.sayakaCutlassID = cfg.getItem("sayakaCutlassID", 15031).getInt();
        	this.mamiGemID = cfg.getItem("mamiGemID", 15040).getInt();
        	this.mamiMusketID = cfg.getItem("mamiGunID", 15041).getInt();
        	this.mamiTeaID = cfg.getItem("mamiTeaID", 15042).getInt();
        	this.kyoukoGemID = cfg.getItem("kyoukoGemID", 15050).getInt();
        	this.kyoukoSpearID = cfg.getItem("kyoukoSpearID", 15051).getInt();
        	//Entity
        	this.MadokaID = cfg.get("entityMadokaID", Configuration.CATEGORY_GENERAL, 250).getInt();
        	this.HomuraID = cfg.get("entityHomuraID", Configuration.CATEGORY_GENERAL, 251).getInt();
        	this.SayakaID = cfg.get("entitySayakaID", Configuration.CATEGORY_GENERAL, 252).getInt();
        	this.MamiID = cfg.get("entityMamiID", Configuration.CATEGORY_GENERAL, 253).getInt();
        	this.KyoukoID = cfg.get("entityKyoukoID", Configuration.CATEGORY_GENERAL, 254).getInt();
        	this.QBID = cfg.get("entityQBID", Configuration.CATEGORY_GENERAL, 255).getInt();
        	this.GriefSeedID = cfg.get("entityGriefSeedID", Configuration.CATEGORY_GENERAL, 500).getInt();
        	this.GSLightLevel = cfg.get("GSLightLevel", Configuration.CATEGORY_GENERAL, 10).getInt();
        	this.KriemhildGretchenID = cfg.get("entityKriemhildGretchenID", Configuration.CATEGORY_GENERAL, 501).getInt();
        	this.GertrudID= cfg.get("entityGertrudID", Configuration.CATEGORY_GENERAL, 502).getInt();
        	this.AdelbertID = cfg.get("entityAdelbertID", Configuration.CATEGORY_GENERAL, 503).getInt();
        	this.AnthonyID = cfg.get("entityAnthonyID", Configuration.CATEGORY_GENERAL, 504).getInt();
        	this.canWalpurgisSpawn = cfg.get("canWalpurgisSpawn", Configuration.CATEGORY_GENERAL, true).getBoolean(true);
        	this.WalpurgisnachtID = cfg.get("entityWalpurgisnachtID", Configuration.CATEGORY_GENERAL, 505).getInt();
        	this.ShadowPuellaMagiID = cfg.get("entityShadowPuellaMagiID", Configuration.CATEGORY_GENERAL, 506).getInt();
        	this.LightArrowID = cfg.get("entityLightArrowID", Configuration.CATEGORY_GENERAL, 750).getInt();
        	this.BulletID = cfg.get("entityBulletID", Configuration.CATEGORY_GENERAL, 751).getInt();
        	this.CutlassID = cfg.get("entityCutlassID", Configuration.CATEGORY_GENERAL, 752).getInt();
        	this.MusketID = cfg.get("entityMusketID", Configuration.CATEGORY_GENERAL, 753).getInt();
        	this.SpearID = cfg.get("entitySpearID", Configuration.CATEGORY_GENERAL, 754).getInt();
        	this.FireLanceID = cfg.get("entityFireLanceID", Configuration.CATEGORY_GENERAL, 800).getInt();
        	this.PrickleID = cfg.get("entityPrickleID", Configuration.CATEGORY_GENERAL, 801).getInt();
        }
        catch (Exception e)
        {
        	FMLLog.log(Level.SEVERE, e, "Error Message");
        }
        finally
        {
        	cfg.save();
        }
    }

    @Mod.Init
    public void init(FMLInitializationEvent event)
    {
        this.loadItems();
        this.loadRecipes();
        this.loadEntities();
        this.proxy.registerTextures();
        this.proxy.registerRenderers();
    }

    public void loadItems()
    {
        //controlItem
        this.madokaRibbon = new ItemMadokaRibbon(this.madokaRibbonID - 256).setIconCoord(0, 0).setItemName("madokaRibbon");
        LanguageRegistry.addName(this.madokaRibbon, "Madoka's Ribbon");
        LanguageRegistry.instance().addNameForObject(this.madokaRibbon, "ja_JP", "まどかのリボン");
        //itemGriedSeed
        this.itemGriefSeed = new ItemGrifSeed(this.itemGriefSeedID - 256).setIconCoord(2, 0).setItemName("itemGriefSeed");
        LanguageRegistry.addName(this.itemGriefSeed, "Grief Seed");
        LanguageRegistry.instance().addNameForObject(this.itemGriefSeed, "ja_JP", "グリーフシード");
        //itemBullet
        this.itemLightArrow = new ItemBullet(this.itemLightArrowID - 256).setIconCoord(3, 0).setItemName("itemLightArrow");
        LanguageRegistry.addName(this.itemLightArrow, "LightArrow");
        LanguageRegistry.instance().addNameForObject(this.itemLightArrow, "ja_JP", "光の矢");
        //itemBullet
        this.itemBullet = new ItemBullet(this.itemBulletID - 256).setIconCoord(4, 0).setItemName("itemBullet");
        LanguageRegistry.addName(this.itemBullet, "Bullet");
        LanguageRegistry.instance().addNameForObject(this.itemBullet, "ja_JP", "銃弾");

        //madokaGem
        this.madokaGem = new ItemSoulGem(this.madokaGemID - 256, 0).setIconCoord(0, 6).setItemName("madokaGem");
        LanguageRegistry.addName(this.madokaGem, "Soul Gem");
        LanguageRegistry.instance().addNameForObject(this.madokaGem, "ja_JP", "ソウルジェム");
        //madokaBow
        this.madokaBow = new ItemMadokaBow(this.madokaBowID - 256).setIconCoord(1, 6).setItemName("madokaBow");
        LanguageRegistry.addName(this.madokaBow, "Madoka's Bow");
        LanguageRegistry.instance().addNameForObject(this.madokaBow, "ja_JP", "まどかの弓");
        //madokaWeapon
        this.madokaWeapon = new ItemMadokaBow(this.madokaWeaponID -256).setIconCoord(4, 6).setItemName("madokaWeapon").setCreativeTab(null);

        //homuraGem
        this.homuraGem = new ItemSoulGem(this.homuraGemID - 256, 1).setIconCoord(0, 7).setItemName("homuraGem");
        LanguageRegistry.addName(this.homuraGem, "Soul Gem");
        LanguageRegistry.instance().addNameForObject(this.homuraGem, "ja_JP", "ソウルジェム");
        //homuraGun1
        this.homuraGun1 = new ItemHomuraGun1(this.homuraGun1ID - 256).setIconCoord(1, 7).setItemName("homuraGun1");
        LanguageRegistry.addName(this.homuraGun1, "Desert Eagle");
        LanguageRegistry.instance().addNameForObject(this.homuraGun1, "ja_JP", "デザートイーグル");
        //homuraGun2
        this.homuraGun2 = new ItemHomuraGun2(this.homuraGun2ID - 256).setIconCoord(2, 7).setItemName("homuraGun2");
        LanguageRegistry.addName(this.homuraGun2, "Howa Type 89 Assault Rifle");
        LanguageRegistry.instance().addNameForObject(this.homuraGun2, "ja_JP", "89式5.56mm小銃");

        //sayakaJem
        this.sayakaGem = new ItemSoulGem(this.sayakaGemID - 256, 2).setIconCoord(0, 8).setItemName("sayakaGem");
        LanguageRegistry.addName(this.sayakaGem, "Soul Gem");
        LanguageRegistry.instance().addNameForObject(this.sayakaGem, "ja_JP", "ソウルジェム");
        //sayakaSword
        this.sayakaCutlass = new ItemMadomagiWeapon(this.sayakaCutlassID - 256).setIconCoord(1, 8).setItemName("sayakaCutlass");
        LanguageRegistry.addName(this.sayakaCutlass, "Sayaka's Cutlass");
        LanguageRegistry.instance().addNameForObject(this.sayakaCutlass, "ja_JP", "さやかの剣");

        //mamiGem
        this.mamiGem = new ItemSoulGem(this.mamiGemID - 256, 3).setIconCoord(0, 9).setItemName("mamiGem");
        LanguageRegistry.addName(this.mamiGem, "Soul Gem");
        LanguageRegistry.instance().addNameForObject(this.mamiGem, "ja_JP", "ソウルジェム");
        //mamiGun
        this.mamiMusket = new ItemMamiGun(this.mamiMusketID - 256).setIconCoord(1, 9).setItemName("mamiGun");
        LanguageRegistry.addName(this.mamiMusket, "Mami's Musket");
        LanguageRegistry.instance().addNameForObject(this.mamiMusket, "ja_JP", "マミの銃");
        //mamiTea
        this.mamiTea = new ItemMamiTea(this.mamiTeaID, 4, 1.2F, false).setAlwaysEdible().setPotionEffect(Potion.regeneration.id, 30, 4, 1.0F).setIconCoord(2, 9).setItemName("mamiTea");
        LanguageRegistry.addName(this.mamiTea, "Mami's Tea");
        LanguageRegistry.instance().addNameForObject(this.mamiTea, "ja_JP", "マミの紅茶");

        //kyoukoGem
        this.kyoukoGem = new ItemSoulGem(this.kyoukoGemID - 256, 4).setIconCoord(0, 10).setItemName("kyoukoGem");
        LanguageRegistry.addName(this.kyoukoGem, "Soul Gem");
        LanguageRegistry.instance().addNameForObject(this.kyoukoGem, "ja_JP", "ソウルジェム");
        //kyoukoSpear
        this.kyoukoSpear = new ItemMadomagiWeapon(this.kyoukoSpearID - 256).setIconCoord(1, 10).setItemName("kyoukoSpear");
        LanguageRegistry.addName(this.kyoukoSpear, "Kyouko's Spear");
        LanguageRegistry.instance().addNameForObject(this.kyoukoSpear, "ja_JP", "杏子の槍");
    }

    public void loadRecipes()
    {
        //madokaRibbon
        GameRegistry.addShapelessRecipe(new ItemStack(this.madokaRibbon, 1), new Object[]{new ItemStack(Block.cloth, 1, 14)});
        //itemLightArrow
        GameRegistry.addShapelessRecipe(new ItemStack(this.itemLightArrow, 4), new Object[]{Item.arrow, Item.redstone, Item.goldNugget, new ItemStack(Item.dyePowder, 1, 4)});
        //itemBullet
        GameRegistry.addShapelessRecipe(new ItemStack(this.itemBullet, 4), new Object[]{Item.ingotIron, Item.gunpowder});

        //madokaBow
        GameRegistry.addRecipe(new ItemStack(this.madokaBow, 1), new Object[]{
        	"  F",
        	" B ",
        	"G  ",
        	Character.valueOf('G'), this.itemGriefSeed,
        	Character.valueOf('B'), Item.bow,
        	Character.valueOf('F'), Block.plantRed});

        //homuraGun1
        GameRegistry.addRecipe(new ItemStack(this.homuraGun1, 1), new Object[]{
        	"I  ",
        	" IP",
        	" IG",
        	Character.valueOf('I'), Item.ingotIron,
        	Character.valueOf('G'), Item.ingotGold,
        	Character.valueOf('P'), Item.gunpowder});
        //homuraGun2
        GameRegistry.addRecipe(new ItemStack(this.homuraGun2, 1), new Object[]{
        	"I  ",
        	"IIP",
        	" ID",
        	Character.valueOf('I'), Item.ingotIron,
        	Character.valueOf('D'), Item.diamond,
        	Character.valueOf('P'), Item.gunpowder});

        //sayakaCutlass
        GameRegistry.addRecipe(new ItemStack(this.sayakaCutlass, 1), new Object[]{
        	" I ",
        	" I ",
        	" G ",
        	Character.valueOf('G'), mod_QB.itemGriefSeed,
        	Character.valueOf('I'), Item.ingotIron});

        //mamiMusket
        GameRegistry.addRecipe(new ItemStack(this.mamiMusket, 1), new Object[]{
        	"I  ",
        	" IF",
        	" IG",
        	Character.valueOf('G'), mod_QB.itemGriefSeed,
        	Character.valueOf('I'), Item.ingotIron,
        	Character.valueOf('F'), Item.flint});

        //kyoukoSpear
        GameRegistry.addRecipe(new ItemStack(this.kyoukoSpear, 1), new Object[]{
        	" G ",
        	" I ",
        	" I ",
        	Character.valueOf('G'), mod_QB.itemGriefSeed,
        	Character.valueOf('I'), Item.ingotIron});
    }

    public void loadEntities()
    {
        //Madomagi
        EntityRegistry.registerGlobalEntityID(EntityMadoka.class, "Madoka", this.MadokaID);
        EntityRegistry.registerModEntity(EntityMadoka.class, "Madoka", this.MadokaID, this, 80, 3, true);
        LanguageRegistry.instance().addStringLocalization("entity.Madoka.name", "en_US", "Madoka");
        LanguageRegistry.instance().addStringLocalization("entity.Madoka.name", "ja_JP", "まどか");
        EntityRegistry.registerGlobalEntityID(EntityHomura.class, "Homura", this.HomuraID);
        EntityRegistry.registerModEntity(EntityHomura.class, "Homura", this.HomuraID, this, 80, 3, true);
        LanguageRegistry.instance().addStringLocalization("entity.Homura.name", "en_US", "Homura");
        LanguageRegistry.instance().addStringLocalization("entity.Homura.name", "ja_JP", "ほむら");
        EntityRegistry.registerGlobalEntityID(EntitySayaka.class, "Sayaka", this.SayakaID);
        EntityRegistry.registerModEntity(EntitySayaka.class, "Sayaka", this.SayakaID, this, 80, 3, true);
        LanguageRegistry.instance().addStringLocalization("entity.Sayaka.name", "en_US", "Sayaka");
        LanguageRegistry.instance().addStringLocalization("entity.Sayaka.name", "ja_JP", "さやか");
        EntityRegistry.registerGlobalEntityID(EntityMami.class, "Mami", this.MamiID);
        EntityRegistry.registerModEntity(EntityMami.class, "Mami", this.MamiID, this, 80, 3, true);
        LanguageRegistry.instance().addStringLocalization("entity.Mami.name", "en_US", "Mami");
        LanguageRegistry.instance().addStringLocalization("entity.Mami.name", "ja_JP", "マミ");
        EntityRegistry.registerGlobalEntityID(EntityKyouko.class, "Kyouko", this.KyoukoID);
        EntityRegistry.registerModEntity(EntityKyouko.class, "Kyouko", this.KyoukoID, this, 80, 3, true);
        LanguageRegistry.instance().addStringLocalization("entity.Kyouko.name", "en_US", "Kyouko");
        LanguageRegistry.instance().addStringLocalization("entity.Kyouko.name", "ja_JP", "杏子");
        EntityRegistry.registerGlobalEntityID(EntityQB.class, "QB", this.QBID, 16777215, 10000);
        EntityRegistry.addSpawn(EntityQB.class, 1, 1, 1, EnumCreatureType.monster, new BiomeGenBase[]{BiomeGenBase.extremeHills, BiomeGenBase.extremeHillsEdge});
        EntityRegistry.registerModEntity(EntityQB.class, "QB", this.QBID, this, 80, 3, true);
        LanguageRegistry.instance().addStringLocalization("entity.QB.name", "en_US", "QB");
        LanguageRegistry.instance().addStringLocalization("entity.QB.name", "ja_JP", "キュゥべえ");
        //Majo
        EntityRegistry.registerGlobalEntityID(EntityKriemhildGretchen.class, "Kriemhild Gretchen", this.KriemhildGretchenID, 10, 100000);
        EntityRegistry.registerModEntity(EntityKriemhildGretchen.class, "KriemhildGretchen", this.KriemhildGretchenID, this, 80, 3, true);
        LanguageRegistry.instance().addStringLocalization("entity.Kriemhild Gretchen.name", "en_US", "KriemhildGretchen");
        EntityRegistry.registerGlobalEntityID(EntityGertrud.class, "Gertrud", this.GertrudID, 10, 100000);
        EntityRegistry.registerModEntity(EntityGertrud.class, "Gertrud", this.GertrudID, this, 80, 3, true);
        LanguageRegistry.instance().addStringLocalization("entity.Gertrud.name", "en_US", "Gertrud");
        EntityRegistry.registerGlobalEntityID(EntityAdelbert.class, "Adelbert", this.AdelbertID, 10, 100000);
        EntityRegistry.registerModEntity(EntityAdelbert.class, "Adelbert", this.AdelbertID, this, 80, 3, true);
        LanguageRegistry.instance().addStringLocalization("entity.Adelbert.name", "en_US", "Adelbert");
        EntityRegistry.registerGlobalEntityID(EntityAnthony.class, "Anthony", this.AnthonyID, 10, 100000);
        EntityRegistry.registerModEntity(EntityAnthony.class, "Anthony", this.AnthonyID, this, 80, 3, true);
        LanguageRegistry.instance().addStringLocalization("entity.Anthony.name", "en_US", "Anthony");
        EntityRegistry.registerGlobalEntityID(EntityWalpurgisnacht.class, "Walpurgisnacht", this.WalpurgisnachtID, 10, 100000);
        EntityRegistry.addSpawn(EntityWalpurgisnacht.class, 100, 1, 1, EnumCreatureType.monster, WorldType.base12Biomes);
        EntityRegistry.registerModEntity(EntityWalpurgisnacht.class, "Walpurgisnacht", this.WalpurgisnachtID, this, 80, 3, true);
        LanguageRegistry.instance().addStringLocalization("entity.Walpurgisnacht.name", "en_US", "Walpurgisnacht");
        EntityRegistry.registerGlobalEntityID(EntityShadowPuellaMagi.class, "ShadowPuellaMagi", this.ShadowPuellaMagiID, 10, 100000);
        EntityRegistry.registerModEntity(EntityShadowPuellaMagi.class, "ShadowPuellaMagi", this.ShadowPuellaMagiID, this, 80, 3, true);
        LanguageRegistry.instance().addStringLocalization("entity.ShadowPuellaMagi.name", "en_US", "ShadowPuellaMagi");
        //Others
        EntityRegistry.registerGlobalEntityID(EntityGriefSeed.class, "GriefSeed", this.GriefSeedID);
        EntityRegistry.addSpawn(EntityGriefSeed.class, 1, 1, 1, EnumCreatureType.monster, WorldType.base12Biomes);
        EntityRegistry.registerModEntity(EntityGriefSeed.class, "GriefSeed", this.GriefSeedID, this, 80, 3, true);
        LanguageRegistry.instance().addStringLocalization("entity.GriefSeed.name", "en_US", "GriefSeed");
        EntityRegistry.registerGlobalEntityID(EntityLightArrow.class, "LightArrow", this.LightArrowID);
        EntityRegistry.registerModEntity(EntityLightArrow.class, "LightArrow", this.LightArrowID, this, 64, 10, true);
        EntityRegistry.registerGlobalEntityID(EntityMadomagiBullet.class, "Bullet", this.BulletID);
        EntityRegistry.registerModEntity(EntityMadomagiBullet.class, "Bullet", this.BulletID, this, 64, 10, true);
        EntityRegistry.registerGlobalEntityID(EntityCutlass.class, "Cutlass", this.CutlassID);
        EntityRegistry.registerModEntity(EntityCutlass.class, "Cutlass", this.CutlassID, this, 64, 20, true);
        ModLoader.registerEntityID(EntityMusket.class, "Musket", this.MusketID);
        EntityRegistry.registerModEntity(EntityMusket.class, "Musket", this.MusketID, this, 64, 20, true);
        ModLoader.registerEntityID(EntitySpear.class, "Spear", this.SpearID);
        EntityRegistry.registerModEntity(EntitySpear.class, "Spear", this.SpearID, this, 64, 20, true);
        ModLoader.registerEntityID(EntityFireLance.class, "FireLance", this.FireLanceID);
        EntityRegistry.registerModEntity(EntityFireLance.class, "FireLance", this.FireLanceID, this, 64, 20, true);
        ModLoader.registerEntityID(EntityPrickle.class, "Prickle", this.PrickleID);
        EntityRegistry.registerModEntity(EntityPrickle.class, "Prickle", this.PrickleID, this, 64, 20, true);
    }
}